/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "bsimcmgdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

int bsimcmgsetup (SMPmatrix *matrix, GENmodel *inModel, CKTcircuit *ckt, int *states)
     /* load the bsimcmg device structure with those pointers needed later 
      * for fast matrix loading 
      */
{
  bsimcmgmodel *model = (bsimcmgmodel*)inModel;
  bsimcmginstance *here;
  
  /*  loop through all the bsimcmg device models */
  for ( ;model != NULL ;model = bsimcmgnextModel(model) )
  {
    if(model->pmos_Given == FALSE) model->pmos=1;
    if(model->nmos_Given == FALSE) model->nmos=1;
    if(model->XL_Given == FALSE) model->XL=0.0;
    if(model->DTEMP_Given == FALSE) model->DTEMP=0.0;
    if(model->DELVTRAND_Given == FALSE) model->DELVTRAND=0.0;
    if(model->U0MULT_Given == FALSE) model->U0MULT=1.0;
    if(model->IDS0MULT_Given == FALSE) model->IDS0MULT=1.0;
    if(model->DEVTYPE_Given == FALSE) model->DEVTYPE=1;
    if(model->TYPE_Given == FALSE) model->TYPE=model->DEVTYPE;
    if(model->BULKMOD_Given == FALSE) model->BULKMOD=0;
    if(model->GEOMOD_Given == FALSE) model->GEOMOD=0;
    if(model->CGEO1SW_Given == FALSE) model->CGEO1SW=0;
    if(model->RDSMOD_Given == FALSE) model->RDSMOD=0;
    if(model->ASYMMOD_Given == FALSE) model->ASYMMOD=0;
    if(model->IGCMOD_Given == FALSE) model->IGCMOD=0;
    if(model->IGBMOD_Given == FALSE) model->IGBMOD=0;
    if(model->GIDLMOD_Given == FALSE) model->GIDLMOD=0;
    if(model->IIMOD_Given == FALSE) model->IIMOD=0;
    if(model->TNOIMOD_Given == FALSE) model->TNOIMOD=0;
    if(model->NQSMOD_Given == FALSE) model->NQSMOD=0;
    if(model->SHMOD_Given == FALSE) model->SHMOD=0;
    if(model->TEMPMOD_Given == FALSE) model->TEMPMOD=0;
    if(model->RGATEMOD_Given == FALSE) model->RGATEMOD=0;
    if(model->RGEOMOD_Given == FALSE) model->RGEOMOD=0;
    if(model->CGEOMOD_Given == FALSE) model->CGEOMOD=0;
    if(model->SH_WARN_Given == FALSE) model->SH_WARN=0;
    if(model->IGCLAMP_Given == FALSE) model->IGCLAMP=1;
    if(model->LINT_Given == FALSE) model->LINT=0.0;
    if(model->LL_Given == FALSE) model->LL=0.0;
    if(model->LLN_Given == FALSE) model->LLN=1.0;
    if(model->DLC_Given == FALSE) model->DLC=0.0;
    if(model->DLCACC_Given == FALSE) model->DLCACC=0.0;
    if(model->DLBIN_Given == FALSE) model->DLBIN=0.0;
    if(model->LLC_Given == FALSE) model->LLC=0.0;
    if(model->EOT_Given == FALSE) model->EOT=1.0e-9;
    if(model->TOXP_Given == FALSE) model->TOXP=1.2e-9;
    if(model->EOTBOX_Given == FALSE) model->EOTBOX=1.4e-7;
    if(model->HFIN_Given == FALSE) model->HFIN=3.0e-8;
    if(model->FECH_Given == FALSE) model->FECH=1.0;
    if(model->DELTAW_Given == FALSE) model->DELTAW=0.0;
    if(model->FECHCV_Given == FALSE) model->FECHCV=1.0;
    if(model->DELTAWCV_Given == FALSE) model->DELTAWCV=0.0;
    if(model->NBODY_Given == FALSE) model->NBODY=1.0e22;
    if(model->NBODYN1_Given == FALSE) model->NBODYN1=0.0;
    if(model->NBODYN2_Given == FALSE) model->NBODYN2=1.0e5;
    if(model->NSD_Given == FALSE) model->NSD=2.0e26;
    if(model->PHIG_Given == FALSE) model->PHIG=4.61;
    if(model->PHIGL_Given == FALSE) model->PHIGL=0.0;
    if(model->PHIGLT_Given == FALSE) model->PHIGLT=0.0;
    if(model->PHIGN1_Given == FALSE) model->PHIGN1=0.0;
    if(model->PHIGN2_Given == FALSE) model->PHIGN2=1.0e5;
    if(model->EPSROX_Given == FALSE) model->EPSROX=3.9;
    if(model->EPSRSUB_Given == FALSE) model->EPSRSUB=11.9;
    if(model->EASUB_Given == FALSE) model->EASUB=4.05;
    if(model->NI0SUB_Given == FALSE) model->NI0SUB=1.1e16;
    if(model->BG0SUB_Given == FALSE) model->BG0SUB=1.12;
    if(model->NC0SUB_Given == FALSE) model->NC0SUB=2.86e25;
    if(model->NGATE_Given == FALSE) model->NGATE=0.0;
    if(model->Imin_Given == FALSE) model->Imin=1.0e-15;
    if(model->CIT_Given == FALSE) model->CIT=0.0;
    if(model->CITR_Given == FALSE) model->CITR=model->CIT;
    if(model->CDSC_Given == FALSE) model->CDSC=7.0e-3;
    if(model->CDSCN1_Given == FALSE) model->CDSCN1=0.0;
    if(model->CDSCN2_Given == FALSE) model->CDSCN2=1.0e5;
    if(model->CDSCD_Given == FALSE) model->CDSCD=7.0e-3;
    if(model->CDSCDN1_Given == FALSE) model->CDSCDN1=0.0;
    if(model->CDSCDN2_Given == FALSE) model->CDSCDN2=1.0e5;
    if(model->CDSCDR_Given == FALSE) model->CDSCDR=model->CDSCD;
    if(model->CDSCDRN1_Given == FALSE) model->CDSCDRN1=model->CDSCDN1;
    if(model->CDSCDRN2_Given == FALSE) model->CDSCDRN2=model->CDSCDN2;
    if(model->DVT0_Given == FALSE) model->DVT0=0.0;
    if(model->DVT1_Given == FALSE) model->DVT1=0.6;
    if(model->DVT1SS_Given == FALSE) model->DVT1SS=model->DVT1;
    if(model->PHIN_Given == FALSE) model->PHIN=0.05;
    if(model->ETA0_Given == FALSE) model->ETA0=0.6;
    if(model->ETA0N1_Given == FALSE) model->ETA0N1=0.0;
    if(model->ETA0N2_Given == FALSE) model->ETA0N2=1.0e5;
    if(model->ETA0LT_Given == FALSE) model->ETA0LT=0.0;
    if(model->TETA0_Given == FALSE) model->TETA0=0.0;
    if(model->ETA0R_Given == FALSE) model->ETA0R=model->ETA0;
    if(model->TETA0R_Given == FALSE) model->TETA0R=model->TETA0;
    if(model->DSUB_Given == FALSE) model->DSUB=1.06;
    if(model->DVTP0_Given == FALSE) model->DVTP0=0.0;
    if(model->DVTP1_Given == FALSE) model->DVTP1=0.0;
    if(model->ADVTP0_Given == FALSE) model->ADVTP0=0.0;
    if(model->BDVTP0_Given == FALSE) model->BDVTP0=1.0e-7;
    if(model->ADVTP1_Given == FALSE) model->ADVTP1=0.0;
    if(model->BDVTP1_Given == FALSE) model->BDVTP1=1.0e-7;
    if(model->DVTP2_Given == FALSE) model->DVTP2=0.0;
    if(model->K1RSCE_Given == FALSE) model->K1RSCE=0.0;
    if(model->LPE0_Given == FALSE) model->LPE0=5.0e-9;
    if(model->DVTSHIFT_Given == FALSE) model->DVTSHIFT=0.0;
    if(model->DVTSHIFTR_Given == FALSE) model->DVTSHIFTR=model->DVTSHIFT;
    if(model->THETASCE_Given == FALSE) model->THETASCE=0.0;
    if(model->THETADIBL_Given == FALSE) model->THETADIBL=0.0;
    if(model->THETASW_Given == FALSE) model->THETASW=0.0;
    if(model->NVTM_Given == FALSE) model->NVTM=0.0;
    if(model->K0_Given == FALSE) model->K0=0.0;
    if(model->K01_Given == FALSE) model->K01=0.0;
    if(model->K0SI_Given == FALSE) model->K0SI=1.0;
    if(model->K0SI1_Given == FALSE) model->K0SI1=0.0;
    if(model->K2SI_Given == FALSE) model->K2SI=model->K0SI;
    if(model->K2SI1_Given == FALSE) model->K2SI1=model->K0SI1;
    if(model->K0SISAT_Given == FALSE) model->K0SISAT=0.0;
    if(model->K0SISAT1_Given == FALSE) model->K0SISAT1=0.0;
    if(model->K2SISAT_Given == FALSE) model->K2SISAT=model->K0SISAT;
    if(model->K2SISAT1_Given == FALSE) model->K2SISAT1=model->K0SISAT1;
    if(model->PHIBE_Given == FALSE) model->PHIBE=0.7;
    if(model->K1_Given == FALSE) model->K1=1.0e-6;
    if(model->K11_Given == FALSE) model->K11=0.0;
    if(model->K2SAT_Given == FALSE) model->K2SAT=0.0;
    if(model->K2SAT1_Given == FALSE) model->K2SAT1=0.0;
    if(model->K2_Given == FALSE) model->K2=0.0;
    if(model->K21_Given == FALSE) model->K21=0.0;
    if(model->QMFACTOR_Given == FALSE) model->QMFACTOR=0.0;
    if(model->QMTCENCV_Given == FALSE) model->QMTCENCV=0.0;
    if(model->QMTCENCVA_Given == FALSE) model->QMTCENCVA=0.0;
    if(model->AQMTCEN_Given == FALSE) model->AQMTCEN=0.0;
    if(model->BQMTCEN_Given == FALSE) model->BQMTCEN=1.2e-8;
    if(model->ETAQM_Given == FALSE) model->ETAQM=0.54;
    if(model->QM0_Given == FALSE) model->QM0=1.0e-3;
    if(model->PQM_Given == FALSE) model->PQM=0.66;
    if(model->QM0ACC_Given == FALSE) model->QM0ACC=1.0e-3;
    if(model->PQMACC_Given == FALSE) model->PQMACC=0.66;
    if(model->VSAT_Given == FALSE) model->VSAT=8.5e4;
    if(model->VSATR_Given == FALSE) model->VSATR=model->VSAT;
    if(model->VSATN1_Given == FALSE) model->VSATN1=0.0;
    if(model->VSATN2_Given == FALSE) model->VSATN2=1.0e5;
    if(model->VSATRN1_Given == FALSE) model->VSATRN1=model->VSATN1;
    if(model->VSATRN2_Given == FALSE) model->VSATRN2=model->VSATN2;
    if(model->AVSAT_Given == FALSE) model->AVSAT=0.0;
    if(model->BVSAT_Given == FALSE) model->BVSAT=1.0e-7;
    if(model->VSAT1_Given == FALSE) model->VSAT1=model->VSAT;
    if(model->VSAT1N1_Given == FALSE) model->VSAT1N1=model->VSATN1;
    if(model->VSAT1N2_Given == FALSE) model->VSAT1N2=model->VSATN2;
    if(model->VSAT1R_Given == FALSE) model->VSAT1R=model->VSAT1;
    if(model->VSAT1RN1_Given == FALSE) model->VSAT1RN1=model->VSAT1N1;
    if(model->VSAT1RN2_Given == FALSE) model->VSAT1RN2=model->VSAT1N2;
    if(model->AVSAT1_Given == FALSE) model->AVSAT1=model->AVSAT;
    if(model->BVSAT1_Given == FALSE) model->BVSAT1=model->BVSAT;
    if(model->DELTAVSAT_Given == FALSE) model->DELTAVSAT=1.0;
    if(model->PSAT_Given == FALSE) model->PSAT=2.0;
    if(model->APSAT_Given == FALSE) model->APSAT=0.0;
    if(model->BPSAT_Given == FALSE) model->BPSAT=1.0;
    if(model->KSATIV_Given == FALSE) model->KSATIV=1.0;
    if(model->KSATIVR_Given == FALSE) model->KSATIVR=model->KSATIV;
    if(model->VSATCV_Given == FALSE) model->VSATCV=model->VSAT;
    if(model->AVSATCV_Given == FALSE) model->AVSATCV=model->AVSAT;
    if(model->BVSATCV_Given == FALSE) model->BVSATCV=model->BVSAT;
    if(model->DELTAVSATCV_Given == FALSE) model->DELTAVSATCV=model->DELTAVSAT;
    if(model->PSATCV_Given == FALSE) model->PSATCV=model->PSAT;
    if(model->APSATCV_Given == FALSE) model->APSATCV=model->APSAT;
    if(model->BPSATCV_Given == FALSE) model->BPSATCV=model->BPSAT;
    if(model->MEXP_Given == FALSE) model->MEXP=4.0;
    if(model->AMEXP_Given == FALSE) model->AMEXP=0.0;
    if(model->BMEXP_Given == FALSE) model->BMEXP=1.0;
    if(model->MEXPR_Given == FALSE) model->MEXPR=model->MEXP;
    if(model->AMEXPR_Given == FALSE) model->AMEXPR=model->AMEXP;
    if(model->BMEXPR_Given == FALSE) model->BMEXPR=model->BMEXP;
    if(model->PTWG_Given == FALSE) model->PTWG=0.0;
    if(model->PTWGR_Given == FALSE) model->PTWGR=model->PTWG;
    if(model->APTWG_Given == FALSE) model->APTWG=0.0;
    if(model->BPTWG_Given == FALSE) model->BPTWG=1.0e-7;
    if(model->AT_Given == FALSE) model->AT=(-1.56e-3);
    if(model->ATR_Given == FALSE) model->ATR=model->AT;
    if(model->ATCV_Given == FALSE) model->ATCV=model->AT;
    if(model->TMEXP_Given == FALSE) model->TMEXP=0.0;
    if(model->TMEXPR_Given == FALSE) model->TMEXPR=model->TMEXP;
    if(model->PTWGT_Given == FALSE) model->PTWGT=4.0e-3;
    if(model->U0_Given == FALSE) model->U0=3.0e-2;
    if(model->U0R_Given == FALSE) model->U0R=model->U0;
    if(model->U0N1_Given == FALSE) model->U0N1=0.0;
    if(model->U0N1R_Given == FALSE) model->U0N1R=model->U0N1;
    if(model->U0N2_Given == FALSE) model->U0N2=1.0e5;
    if(model->U0N2R_Given == FALSE) model->U0N2R=model->U0N2;
    if(model->U0LT_Given == FALSE) model->U0LT=0.0;
    if(model->ETAMOB_Given == FALSE) model->ETAMOB=2.0;
    if(model->UP_Given == FALSE) model->UP=0.0;
    if(model->LPA_Given == FALSE) model->LPA=1.0;
    if(model->UPR_Given == FALSE) model->UPR=model->UP;
    if(model->LPAR_Given == FALSE) model->LPAR=model->LPA;
    if(model->UA_Given == FALSE) model->UA=0.3;
    if(model->UAR_Given == FALSE) model->UAR=model->UA;
    if(model->AUA_Given == FALSE) model->AUA=0.0;
    if(model->AUAR_Given == FALSE) model->AUAR=model->AUA;
    if(model->BUA_Given == FALSE) model->BUA=1.0e-7;
    if(model->BUAR_Given == FALSE) model->BUAR=model->BUA;
    if(model->UC_Given == FALSE) model->UC=0.0;
    if(model->UCR_Given == FALSE) model->UCR=model->UC;
    if(model->EU_Given == FALSE) model->EU=2.5;
    if(model->EUR_Given == FALSE) model->EUR=model->EU;
    if(model->AEU_Given == FALSE) model->AEU=0.0;
    if(model->AEUR_Given == FALSE) model->AEUR=model->AEU;
    if(model->BEU_Given == FALSE) model->BEU=1.0e-7;
    if(model->BEUR_Given == FALSE) model->BEUR=model->BEU;
    if(model->UD_Given == FALSE) model->UD=0.0;
    if(model->UDR_Given == FALSE) model->UDR=model->UD;
    if(model->AUD_Given == FALSE) model->AUD=0.0;
    if(model->AUDR_Given == FALSE) model->AUDR=model->AUD;
    if(model->BUD_Given == FALSE) model->BUD=5.0e-8;
    if(model->BUDR_Given == FALSE) model->BUDR=model->BUD;
    if(model->UCS_Given == FALSE) model->UCS=1.0;
    if(model->UTE_Given == FALSE) model->UTE=0.0;
    if(model->UTER_Given == FALSE) model->UTER=model->UTE;
    if(model->UTL_Given == FALSE) model->UTL=(-1.5e-3);
    if(model->UTLR_Given == FALSE) model->UTLR=model->UTL;
    if(model->EMOBT_Given == FALSE) model->EMOBT=0.0;
    if(model->UA1_Given == FALSE) model->UA1=1.032e-3;
    if(model->UA1R_Given == FALSE) model->UA1R=model->UA1;
    if(model->UC1_Given == FALSE) model->UC1=5.6e-11;
    if(model->UC1R_Given == FALSE) model->UC1R=model->UC1;
    if(model->UD1_Given == FALSE) model->UD1=0.0;
    if(model->UD1R_Given == FALSE) model->UD1R=model->UD1;
    if(model->UCSTE_Given == FALSE) model->UCSTE=(-4.775e-3);
    if(model->CHARGEWF_Given == FALSE) model->CHARGEWF=0.0;
    if(model->RDSWMIN_Given == FALSE) model->RDSWMIN=0.0;
    if(model->RDSW_Given == FALSE) model->RDSW=1.0e2;
    if(model->ARDSW_Given == FALSE) model->ARDSW=0.0;
    if(model->BRDSW_Given == FALSE) model->BRDSW=1.0e-7;
    if(model->RSWMIN_Given == FALSE) model->RSWMIN=0.0;
    if(model->RSW_Given == FALSE) model->RSW=5.0e1;
    if(model->ARSW_Given == FALSE) model->ARSW=0.0;
    if(model->BRSW_Given == FALSE) model->BRSW=1.0e-7;
    if(model->RDWMIN_Given == FALSE) model->RDWMIN=0.0;
    if(model->RDW_Given == FALSE) model->RDW=5.0e1;
    if(model->ARDW_Given == FALSE) model->ARDW=0.0;
    if(model->BRDW_Given == FALSE) model->BRDW=1.0e-7;
    if(model->RSDR_Given == FALSE) model->RSDR=0.0;
    if(model->RSDRR_Given == FALSE) model->RSDRR=model->RSDR;
    if(model->RDDR_Given == FALSE) model->RDDR=model->RSDR;
    if(model->RDDRR_Given == FALSE) model->RDDRR=model->RDDR;
    if(model->PRSDR_Given == FALSE) model->PRSDR=1.0;
    if(model->PRDDR_Given == FALSE) model->PRDDR=model->PRSDR;
    if(model->PRWGS_Given == FALSE) model->PRWGS=0.0;
    if(model->PRWGD_Given == FALSE) model->PRWGD=model->PRWGS;
    if(model->WR_Given == FALSE) model->WR=1.0;
    if(model->PRT_Given == FALSE) model->PRT=1.0e-3;
    if(model->TRSDR_Given == FALSE) model->TRSDR=0.0;
    if(model->TRDDR_Given == FALSE) model->TRDDR=model->TRSDR;
    if(model->PDIBL1_Given == FALSE) model->PDIBL1=1.3;
    if(model->PDIBL1R_Given == FALSE) model->PDIBL1R=model->PDIBL1;
    if(model->PDIBL2_Given == FALSE) model->PDIBL2=2.0e-4;
    if(model->PDIBL2R_Given == FALSE) model->PDIBL2R=model->PDIBL2;
    if(model->DROUT_Given == FALSE) model->DROUT=1.06;
    if(model->PVAG_Given == FALSE) model->PVAG=1.0;
    if(model->PCLM_Given == FALSE) model->PCLM=1.3e-2;
    if(model->PCLMR_Given == FALSE) model->PCLMR=model->PCLM;
    if(model->APCLM_Given == FALSE) model->APCLM=0.0;
    if(model->APCLMR_Given == FALSE) model->APCLMR=model->APCLM;
    if(model->BPCLM_Given == FALSE) model->BPCLM=1.0e-7;
    if(model->BPCLMR_Given == FALSE) model->BPCLMR=model->BPCLM;
    if(model->PCLMG_Given == FALSE) model->PCLMG=0.0;
    if(model->PCLMCV_Given == FALSE) model->PCLMCV=model->PCLM;
    if(model->A1_Given == FALSE) model->A1=0.0;
    if(model->A11_Given == FALSE) model->A11=0.0;
    if(model->A2_Given == FALSE) model->A2=0.0;
    if(model->A21_Given == FALSE) model->A21=0.0;
    if(model->RGEXT_Given == FALSE) model->RGEXT=0.0;
    if(model->RGFIN_Given == FALSE) model->RGFIN=1.0e-3;
    if(model->RSHS_Given == FALSE) model->RSHS=0.0;
    if(model->RSHD_Given == FALSE) model->RSHD=model->RSHS;
    if(model->HEPI_Given == FALSE) model->HEPI=1.0e-8;
    if(model->TSILI_Given == FALSE) model->TSILI=1.0e-8;
    if(model->RHOC_Given == FALSE) model->RHOC=1.0e-12;
    if(model->RHORSD_Given == FALSE) model->RHORSD=1.0;
    if(model->CRATIO_Given == FALSE) model->CRATIO=0.5;
    if(model->DELTAPRSD_Given == FALSE) model->DELTAPRSD=0.0;
    if(model->SDTERM_Given == FALSE) model->SDTERM=0;
    if(model->LSP_Given == FALSE) model->LSP=(-1);
    if(model->EPSRSP_Given == FALSE) model->EPSRSP=3.9;
    if(model->TGATE_Given == FALSE) model->TGATE=3.0e-8;
    if(model->TMASK_Given == FALSE) model->TMASK=3.0e-8;
    if(model->ASILIEND_Given == FALSE) model->ASILIEND=0.0;
    if(model->ARSDEND_Given == FALSE) model->ARSDEND=0.0;
    if(model->PRSDEND_Given == FALSE) model->PRSDEND=0.0;
    if(model->NSDE_Given == FALSE) model->NSDE=2.0e25;
    if(model->RGEOA_Given == FALSE) model->RGEOA=1.0;
    if(model->RGEOB_Given == FALSE) model->RGEOB=0.0;
    if(model->RGEOC_Given == FALSE) model->RGEOC=0.0;
    if(model->RGEOD_Given == FALSE) model->RGEOD=0.0;
    if(model->RGEOE_Given == FALSE) model->RGEOE=0.0;
    if(model->CGEOA_Given == FALSE) model->CGEOA=1.0;
    if(model->CGEOB_Given == FALSE) model->CGEOB=0.0;
    if(model->CGEOC_Given == FALSE) model->CGEOC=0.0;
    if(model->CGEOD_Given == FALSE) model->CGEOD=0.0;
    if(model->CGEOE_Given == FALSE) model->CGEOE=1.0;
    if(model->AIGBINV_Given == FALSE) model->AIGBINV=1.11e-2;
    if(model->AIGBINV1_Given == FALSE) model->AIGBINV1=0.0;
    if(model->BIGBINV_Given == FALSE) model->BIGBINV=9.49e-4;
    if(model->CIGBINV_Given == FALSE) model->CIGBINV=6.0e-3;
    if(model->EIGBINV_Given == FALSE) model->EIGBINV=1.1;
    if(model->NIGBINV_Given == FALSE) model->NIGBINV=3.0;
    if(model->AIGBACC_Given == FALSE) model->AIGBACC=1.36e-2;
    if(model->AIGBACC1_Given == FALSE) model->AIGBACC1=0.0;
    if(model->BIGBACC_Given == FALSE) model->BIGBACC=1.71e-3;
    if(model->CIGBACC_Given == FALSE) model->CIGBACC=7.5e-2;
    if(model->NIGBACC_Given == FALSE) model->NIGBACC=1.0;
    if(model->AIGC_Given == FALSE) model->AIGC=1.36e-2;
    if(model->AIGC1_Given == FALSE) model->AIGC1=0.0;
    if(model->BIGC_Given == FALSE) model->BIGC=1.71e-3;
    if(model->CIGC_Given == FALSE) model->CIGC=7.5e-2;
    if(model->PIGCD_Given == FALSE) model->PIGCD=1.0;
    if(model->DLCIGS_Given == FALSE) model->DLCIGS=0.0;
    if(model->AIGS_Given == FALSE) model->AIGS=1.36e-2;
    if(model->AIGS1_Given == FALSE) model->AIGS1=0.0;
    if(model->BIGS_Given == FALSE) model->BIGS=1.71e-3;
    if(model->CIGS_Given == FALSE) model->CIGS=7.5e-2;
    if(model->DLCIGD_Given == FALSE) model->DLCIGD=model->DLCIGS;
    if(model->AIGD_Given == FALSE) model->AIGD=model->AIGS;
    if(model->AIGD1_Given == FALSE) model->AIGD1=model->AIGS1;
    if(model->BIGD_Given == FALSE) model->BIGD=model->BIGS;
    if(model->CIGD_Given == FALSE) model->CIGD=model->CIGS;
    if(model->VFBSD_Given == FALSE) model->VFBSD=0.0;
    if(model->VFBSDCV_Given == FALSE) model->VFBSDCV=model->VFBSD;
    if(model->TOXREF_Given == FALSE) model->TOXREF=1.2e-9;
    if(model->TOXG_Given == FALSE) model->TOXG=model->TOXP;
    if(model->NTOX_Given == FALSE) model->NTOX=1.0;
    if(model->POXEDGE_Given == FALSE) model->POXEDGE=1.0;
    if(model->AGISL_Given == FALSE) model->AGISL=6.055e-12;
    if(model->BGISL_Given == FALSE) model->BGISL=3.0e8;
    if(model->CGISL_Given == FALSE) model->CGISL=0.5;
    if(model->EGISL_Given == FALSE) model->EGISL=0.2;
    if(model->PGISL_Given == FALSE) model->PGISL=1.0;
    if(model->AGIDL_Given == FALSE) model->AGIDL=model->AGISL;
    if(model->BGIDL_Given == FALSE) model->BGIDL=model->BGISL;
    if(model->CGIDL_Given == FALSE) model->CGIDL=model->CGISL;
    if(model->EGIDL_Given == FALSE) model->EGIDL=model->EGISL;
    if(model->PGIDL_Given == FALSE) model->PGIDL=model->PGISL;
    if(model->ALPHA0_Given == FALSE) model->ALPHA0=0.0;
    if(model->ALPHA01_Given == FALSE) model->ALPHA01=0.0;
    if(model->ALPHA1_Given == FALSE) model->ALPHA1=0.0;
    if(model->ALPHA11_Given == FALSE) model->ALPHA11=0.0;
    if(model->BETA0_Given == FALSE) model->BETA0=0.0;
    if(model->ALPHAII0_Given == FALSE) model->ALPHAII0=0.0;
    if(model->ALPHAII01_Given == FALSE) model->ALPHAII01=0.0;
    if(model->ALPHAII1_Given == FALSE) model->ALPHAII1=0.0;
    if(model->ALPHAII11_Given == FALSE) model->ALPHAII11=0.0;
    if(model->BETAII0_Given == FALSE) model->BETAII0=0.0;
    if(model->BETAII1_Given == FALSE) model->BETAII1=0.0;
    if(model->BETAII2_Given == FALSE) model->BETAII2=0.1;
    if(model->ESATII_Given == FALSE) model->ESATII=1.0e7;
    if(model->LII_Given == FALSE) model->LII=0.5e-9;
    if(model->SII0_Given == FALSE) model->SII0=0.5;
    if(model->SII1_Given == FALSE) model->SII1=0.1;
    if(model->SII2_Given == FALSE) model->SII2=0.0;
    if(model->SIID_Given == FALSE) model->SIID=0.0;
    if(model->IIMOD2CLAMP1_Given == FALSE) model->IIMOD2CLAMP1=0.1;
    if(model->IIMOD2CLAMP2_Given == FALSE) model->IIMOD2CLAMP2=0.1;
    if(model->IIMOD2CLAMP3_Given == FALSE) model->IIMOD2CLAMP3=0.1;
    if(model->EOTACC_Given == FALSE) model->EOTACC=model->EOT;
    if(model->DELVFBACC_Given == FALSE) model->DELVFBACC=0.0;
    if(model->CFS_Given == FALSE) model->CFS=2.5e-11;
    if(model->CFD_Given == FALSE) model->CFD=model->CFS;
    if(model->CGSO_Given == FALSE) model->CGSO=0.0;
    if(model->CGDO_Given == FALSE) model->CGDO=model->CGSO;
    if(model->CGSL_Given == FALSE) model->CGSL=0.0;
    if(model->CGDL_Given == FALSE) model->CGDL=model->CGSL;
    if(model->CKAPPAS_Given == FALSE) model->CKAPPAS=0.6;
    if(model->CKAPPAD_Given == FALSE) model->CKAPPAD=model->CKAPPAS;
    if(model->CGBO_Given == FALSE) model->CGBO=0.0;
    if(model->CGBN_Given == FALSE) model->CGBN=0.0;
    if(model->CGBL_Given == FALSE) model->CGBL=0.0;
    if(model->CKAPPAB_Given == FALSE) model->CKAPPAB=0.6;
    if(model->CSDESW_Given == FALSE) model->CSDESW=0.0;
    if(model->CJS_Given == FALSE) model->CJS=5.0e-4;
    if(model->CJD_Given == FALSE) model->CJD=model->CJS;
    if(model->CJSWS_Given == FALSE) model->CJSWS=5.0e-10;
    if(model->CJSWD_Given == FALSE) model->CJSWD=model->CJSWS;
    if(model->CJSWGS_Given == FALSE) model->CJSWGS=0.0;
    if(model->CJSWGD_Given == FALSE) model->CJSWGD=model->CJSWGS;
    if(model->PBS_Given == FALSE) model->PBS=1.0;
    if(model->PBD_Given == FALSE) model->PBD=model->PBS;
    if(model->PBSWS_Given == FALSE) model->PBSWS=1.0;
    if(model->PBSWD_Given == FALSE) model->PBSWD=model->PBSWS;
    if(model->PBSWGS_Given == FALSE) model->PBSWGS=model->PBSWS;
    if(model->PBSWGD_Given == FALSE) model->PBSWGD=model->PBSWGS;
    if(model->MJS_Given == FALSE) model->MJS=0.5;
    if(model->MJD_Given == FALSE) model->MJD=model->MJS;
    if(model->MJSWS_Given == FALSE) model->MJSWS=0.33;
    if(model->MJSWD_Given == FALSE) model->MJSWD=model->MJSWS;
    if(model->MJSWGS_Given == FALSE) model->MJSWGS=model->MJSWS;
    if(model->MJSWGD_Given == FALSE) model->MJSWGD=model->MJSWGS;
    if(model->SJS_Given == FALSE) model->SJS=0.0;
    if(model->SJD_Given == FALSE) model->SJD=model->SJS;
    if(model->SJSWS_Given == FALSE) model->SJSWS=0.0;
    if(model->SJSWD_Given == FALSE) model->SJSWD=model->SJSWS;
    if(model->SJSWGS_Given == FALSE) model->SJSWGS=0.0;
    if(model->SJSWGD_Given == FALSE) model->SJSWGD=model->SJSWGS;
    if(model->MJS2_Given == FALSE) model->MJS2=1.25e-1;
    if(model->MJD2_Given == FALSE) model->MJD2=model->MJS2;
    if(model->MJSWS2_Given == FALSE) model->MJSWS2=8.3e-2;
    if(model->MJSWD2_Given == FALSE) model->MJSWD2=model->MJSWS2;
    if(model->MJSWGS2_Given == FALSE) model->MJSWGS2=model->MJSWS2;
    if(model->MJSWGD2_Given == FALSE) model->MJSWGD2=model->MJSWGS2;
    if(model->JSS_Given == FALSE) model->JSS=1.0e-4;
    if(model->JSD_Given == FALSE) model->JSD=model->JSS;
    if(model->JSWS_Given == FALSE) model->JSWS=0.0;
    if(model->JSWD_Given == FALSE) model->JSWD=model->JSWS;
    if(model->JSWGS_Given == FALSE) model->JSWGS=0.0;
    if(model->JSWGD_Given == FALSE) model->JSWGD=model->JSWGS;
    if(model->NJS_Given == FALSE) model->NJS=1.0;
    if(model->NJD_Given == FALSE) model->NJD=model->NJS;
    if(model->IJTHSFWD_Given == FALSE) model->IJTHSFWD=0.1;
    if(model->IJTHDFWD_Given == FALSE) model->IJTHDFWD=model->IJTHSFWD;
    if(model->IJTHSREV_Given == FALSE) model->IJTHSREV=0.1;
    if(model->IJTHDREV_Given == FALSE) model->IJTHDREV=model->IJTHSREV;
    if(model->BVS_Given == FALSE) model->BVS=1.0e1;
    if(model->BVD_Given == FALSE) model->BVD=model->BVS;
    if(model->XJBVS_Given == FALSE) model->XJBVS=1.0;
    if(model->XJBVD_Given == FALSE) model->XJBVD=model->XJBVS;
    if(model->JTSS_Given == FALSE) model->JTSS=0.0;
    if(model->JTSD_Given == FALSE) model->JTSD=model->JTSS;
    if(model->JTSSWS_Given == FALSE) model->JTSSWS=0.0;
    if(model->JTSSWD_Given == FALSE) model->JTSSWD=model->JTSSWS;
    if(model->JTSSWGS_Given == FALSE) model->JTSSWGS=0.0;
    if(model->JTSSWGD_Given == FALSE) model->JTSSWGD=model->JTSSWGS;
    if(model->JTWEFF_Given == FALSE) model->JTWEFF=0.0;
    if(model->NJTS_Given == FALSE) model->NJTS=2.0e1;
    if(model->NJTSD_Given == FALSE) model->NJTSD=model->NJTS;
    if(model->NJTSSW_Given == FALSE) model->NJTSSW=2.0e1;
    if(model->NJTSSWD_Given == FALSE) model->NJTSSWD=model->NJTSSW;
    if(model->NJTSSWG_Given == FALSE) model->NJTSSWG=2.0e1;
    if(model->NJTSSWGD_Given == FALSE) model->NJTSSWGD=model->NJTSSWG;
    if(model->VTSS_Given == FALSE) model->VTSS=1.0e1;
    if(model->VTSD_Given == FALSE) model->VTSD=model->VTSS;
    if(model->VTSSWS_Given == FALSE) model->VTSSWS=1.0e1;
    if(model->VTSSWD_Given == FALSE) model->VTSSWD=model->VTSSWS;
    if(model->VTSSWGS_Given == FALSE) model->VTSSWGS=1.0e1;
    if(model->VTSSWGD_Given == FALSE) model->VTSSWGD=model->VTSSWGS;
    if(model->LINTIGEN_Given == FALSE) model->LINTIGEN=0.0;
    if(model->NTGEN_Given == FALSE) model->NTGEN=1.0;
    if(model->AIGEN_Given == FALSE) model->AIGEN=0.0;
    if(model->BIGEN_Given == FALSE) model->BIGEN=0.0;
    if(model->XRCRG1_Given == FALSE) model->XRCRG1=1.2e1;
    if(model->XRCRG2_Given == FALSE) model->XRCRG2=1.0;
    if(model->NSEG_Given == FALSE) model->NSEG=4;
    if(model->EF_Given == FALSE) model->EF=1.0;
    if(model->EM_Given == FALSE) model->EM=4.1e7;
    if(model->NOIA_Given == FALSE) model->NOIA=6.25e39;
    if(model->NOIB_Given == FALSE) model->NOIB=3.125e24;
    if(model->NOIC_Given == FALSE) model->NOIC=8.75e7;
    if(model->LINTNOI_Given == FALSE) model->LINTNOI=0.0;
    if(model->NTNOI_Given == FALSE) model->NTNOI=1.0;
    if(model->TNOIA_Given == FALSE) model->TNOIA=1.5;
    if(model->TNOIB_Given == FALSE) model->TNOIB=3.5;
    if(model->RNOIA_Given == FALSE) model->RNOIA=5.77e-1;
    if(model->RNOIB_Given == FALSE) model->RNOIB=3.7e-1;
    if(model->TNOIC_Given == FALSE) model->TNOIC=3.5;
    if(model->RNOIC_Given == FALSE) model->RNOIC=3.95e-1;
    if(model->SCALEN_Given == FALSE) model->SCALEN=1.0e5;
    if(model->TNOM_Given == FALSE) model->TNOM=27.0;
    if(model->TBGASUB_Given == FALSE) model->TBGASUB=7.02e-4;
    if(model->TBGBSUB_Given == FALSE) model->TBGBSUB=1.108e3;
    if(model->KT1_Given == FALSE) model->KT1=0.0;
    if(model->KT1L_Given == FALSE) model->KT1L=0.0;
    if(model->TSS_Given == FALSE) model->TSS=0.0;
    if(model->IIT_Given == FALSE) model->IIT=(-0.5);
    if(model->TII_Given == FALSE) model->TII=0.0;
    if(model->TGIDL_Given == FALSE) model->TGIDL=(-3.0e-3);
    if(model->IGT_Given == FALSE) model->IGT=2.5;
    if(model->TCJ_Given == FALSE) model->TCJ=0.0;
    if(model->TCJSW_Given == FALSE) model->TCJSW=0.0;
    if(model->TCJSWG_Given == FALSE) model->TCJSWG=0.0;
    if(model->TPB_Given == FALSE) model->TPB=0.0;
    if(model->TPBSW_Given == FALSE) model->TPBSW=0.0;
    if(model->TPBSWG_Given == FALSE) model->TPBSWG=0.0;
    if(model->XTIS_Given == FALSE) model->XTIS=3.0;
    if(model->XTID_Given == FALSE) model->XTID=model->XTIS;
    if(model->XTSS_Given == FALSE) model->XTSS=2.0e-2;
    if(model->XTSD_Given == FALSE) model->XTSD=model->XTSS;
    if(model->XTSSWS_Given == FALSE) model->XTSSWS=2.0e-2;
    if(model->XTSSWD_Given == FALSE) model->XTSSWD=model->XTSSWS;
    if(model->XTSSWGS_Given == FALSE) model->XTSSWGS=2.0e-2;
    if(model->XTSSWGD_Given == FALSE) model->XTSSWGD=model->XTSSWGS;
    if(model->TNJTS_Given == FALSE) model->TNJTS=0.0;
    if(model->TNJTSD_Given == FALSE) model->TNJTSD=model->TNJTS;
    if(model->TNJTSSW_Given == FALSE) model->TNJTSSW=0.0;
    if(model->TNJTSSWD_Given == FALSE) model->TNJTSSWD=model->TNJTSSW;
    if(model->TNJTSSWG_Given == FALSE) model->TNJTSSWG=0.0;
    if(model->TNJTSSWGD_Given == FALSE) model->TNJTSSWGD=model->TNJTSSWG;
    if(model->RTH0_Given == FALSE) model->RTH0=1.0e-2;
    if(model->CTH0_Given == FALSE) model->CTH0=1.0e-5;
    if(model->WTH0_Given == FALSE) model->WTH0=0.0;
    if(model->ASHEXP_Given == FALSE) model->ASHEXP=1.0;
    if(model->BSHEXP_Given == FALSE) model->BSHEXP=1.0;
    if(model->ACH_UFCM_Given == FALSE) model->ACH_UFCM=1.0;
    if(model->CINS_UFCM_Given == FALSE) model->CINS_UFCM=1.0;
    if(model->W_UFCM_Given == FALSE) model->W_UFCM=1.0;
    if(model->TFIN_TOP_Given == FALSE) model->TFIN_TOP=1.5e-8;
    if(model->TFIN_BASE_Given == FALSE) model->TFIN_BASE=1.5e-8;
    if(model->QMFACTORCV_Given == FALSE) model->QMFACTORCV=0.0;
    if(model->ALPHA_UFCM_Given == FALSE) model->ALPHA_UFCM=0.5556;
    if(model->LNBODY_Given == FALSE) model->LNBODY=0.0;
    if(model->NNBODY_Given == FALSE) model->NNBODY=0.0;
    if(model->PNBODY_Given == FALSE) model->PNBODY=0.0;
    if(model->LPHIG_Given == FALSE) model->LPHIG=0.0;
    if(model->NPHIG_Given == FALSE) model->NPHIG=0.0;
    if(model->PPHIG_Given == FALSE) model->PPHIG=0.0;
    if(model->LNGATE_Given == FALSE) model->LNGATE=0.0;
    if(model->NNGATE_Given == FALSE) model->NNGATE=0.0;
    if(model->PNGATE_Given == FALSE) model->PNGATE=0.0;
    if(model->LCIT_Given == FALSE) model->LCIT=0.0;
    if(model->NCIT_Given == FALSE) model->NCIT=0.0;
    if(model->PCIT_Given == FALSE) model->PCIT=0.0;
    if(model->LCITR_Given == FALSE) model->LCITR=model->LCIT;
    if(model->NCITR_Given == FALSE) model->NCITR=model->NCIT;
    if(model->PCITR_Given == FALSE) model->PCITR=model->PCIT;
    if(model->LCDSC_Given == FALSE) model->LCDSC=0.0;
    if(model->NCDSC_Given == FALSE) model->NCDSC=0.0;
    if(model->PCDSC_Given == FALSE) model->PCDSC=0.0;
    if(model->LCDSCD_Given == FALSE) model->LCDSCD=0.0;
    if(model->NCDSCD_Given == FALSE) model->NCDSCD=0.0;
    if(model->PCDSCD_Given == FALSE) model->PCDSCD=0.0;
    if(model->LCDSCDR_Given == FALSE) model->LCDSCDR=model->LCDSCD;
    if(model->NCDSCDR_Given == FALSE) model->NCDSCDR=model->NCDSCD;
    if(model->PCDSCDR_Given == FALSE) model->PCDSCDR=model->PCDSCD;
    if(model->LDVT0_Given == FALSE) model->LDVT0=0.0;
    if(model->NDVT0_Given == FALSE) model->NDVT0=0.0;
    if(model->PDVT0_Given == FALSE) model->PDVT0=0.0;
    if(model->LDVT1_Given == FALSE) model->LDVT1=0.0;
    if(model->NDVT1_Given == FALSE) model->NDVT1=0.0;
    if(model->PDVT1_Given == FALSE) model->PDVT1=0.0;
    if(model->LDVT1SS_Given == FALSE) model->LDVT1SS=model->LDVT1;
    if(model->NDVT1SS_Given == FALSE) model->NDVT1SS=model->NDVT1;
    if(model->PDVT1SS_Given == FALSE) model->PDVT1SS=model->PDVT1;
    if(model->LPHIN_Given == FALSE) model->LPHIN=0.0;
    if(model->NPHIN_Given == FALSE) model->NPHIN=0.0;
    if(model->PPHIN_Given == FALSE) model->PPHIN=0.0;
    if(model->LETA0_Given == FALSE) model->LETA0=0.0;
    if(model->NETA0_Given == FALSE) model->NETA0=0.0;
    if(model->PETA0_Given == FALSE) model->PETA0=0.0;
    if(model->LETA0R_Given == FALSE) model->LETA0R=model->LETA0;
    if(model->NETA0R_Given == FALSE) model->NETA0R=model->NETA0;
    if(model->PETA0R_Given == FALSE) model->PETA0R=model->PETA0;
    if(model->LDSUB_Given == FALSE) model->LDSUB=0.0;
    if(model->NDSUB_Given == FALSE) model->NDSUB=0.0;
    if(model->PDSUB_Given == FALSE) model->PDSUB=0.0;
    if(model->LK1RSCE_Given == FALSE) model->LK1RSCE=0.0;
    if(model->NK1RSCE_Given == FALSE) model->NK1RSCE=0.0;
    if(model->PK1RSCE_Given == FALSE) model->PK1RSCE=0.0;
    if(model->LLPE0_Given == FALSE) model->LLPE0=0.0;
    if(model->NLPE0_Given == FALSE) model->NLPE0=0.0;
    if(model->PLPE0_Given == FALSE) model->PLPE0=0.0;
    if(model->LDVTSHIFT_Given == FALSE) model->LDVTSHIFT=0.0;
    if(model->NDVTSHIFT_Given == FALSE) model->NDVTSHIFT=0.0;
    if(model->PDVTSHIFT_Given == FALSE) model->PDVTSHIFT=0.0;
    if(model->LDVTSHIFTR_Given == FALSE) model->LDVTSHIFTR=model->LDVTSHIFT;
    if(model->NDVTSHIFTR_Given == FALSE) model->NDVTSHIFTR=model->NDVTSHIFT;
    if(model->PDVTSHIFTR_Given == FALSE) model->PDVTSHIFTR=model->PDVTSHIFT;
    if(model->LPHIBE_Given == FALSE) model->LPHIBE=0.0;
    if(model->NPHIBE_Given == FALSE) model->NPHIBE=0.0;
    if(model->PPHIBE_Given == FALSE) model->PPHIBE=0.0;
    if(model->LK0_Given == FALSE) model->LK0=0.0;
    if(model->NK0_Given == FALSE) model->NK0=0.0;
    if(model->PK0_Given == FALSE) model->PK0=0.0;
    if(model->LK01_Given == FALSE) model->LK01=0.0;
    if(model->NK01_Given == FALSE) model->NK01=0.0;
    if(model->PK01_Given == FALSE) model->PK01=0.0;
    if(model->LK0SI_Given == FALSE) model->LK0SI=0.0;
    if(model->NK0SI_Given == FALSE) model->NK0SI=0.0;
    if(model->PK0SI_Given == FALSE) model->PK0SI=0.0;
    if(model->LK0SI1_Given == FALSE) model->LK0SI1=0.0;
    if(model->NK0SI1_Given == FALSE) model->NK0SI1=0.0;
    if(model->PK0SI1_Given == FALSE) model->PK0SI1=0.0;
    if(model->LK1_Given == FALSE) model->LK1=0.0;
    if(model->NK1_Given == FALSE) model->NK1=0.0;
    if(model->PK1_Given == FALSE) model->PK1=0.0;
    if(model->LK11_Given == FALSE) model->LK11=0.0;
    if(model->NK11_Given == FALSE) model->NK11=0.0;
    if(model->PK11_Given == FALSE) model->PK11=0.0;
    if(model->LK2SI_Given == FALSE) model->LK2SI=model->LK0SI;
    if(model->NK2SI_Given == FALSE) model->NK2SI=model->NK0SI;
    if(model->PK2SI_Given == FALSE) model->PK2SI=model->PK0SI;
    if(model->LK2SI1_Given == FALSE) model->LK2SI1=model->LK0SI1;
    if(model->NK2SI1_Given == FALSE) model->NK2SI1=model->NK0SI1;
    if(model->PK2SI1_Given == FALSE) model->PK2SI1=model->PK0SI1;
    if(model->LK0SISAT_Given == FALSE) model->LK0SISAT=0.0;
    if(model->NK0SISAT_Given == FALSE) model->NK0SISAT=0.0;
    if(model->PK0SISAT_Given == FALSE) model->PK0SISAT=0.0;
    if(model->LK0SISAT1_Given == FALSE) model->LK0SISAT1=0.0;
    if(model->NK0SISAT1_Given == FALSE) model->NK0SISAT1=0.0;
    if(model->PK0SISAT1_Given == FALSE) model->PK0SISAT1=0.0;
    if(model->LK2SISAT_Given == FALSE) model->LK2SISAT=model->LK0SISAT;
    if(model->NK2SISAT_Given == FALSE) model->NK2SISAT=model->NK0SISAT;
    if(model->PK2SISAT_Given == FALSE) model->PK2SISAT=model->PK0SISAT;
    if(model->LK2SISAT1_Given == FALSE) model->LK2SISAT1=model->LK0SISAT1;
    if(model->NK2SISAT1_Given == FALSE) model->NK2SISAT1=model->NK0SISAT1;
    if(model->PK2SISAT1_Given == FALSE) model->PK2SISAT1=model->PK0SISAT1;
    if(model->LK2SAT_Given == FALSE) model->LK2SAT=0.0;
    if(model->NK2SAT_Given == FALSE) model->NK2SAT=0.0;
    if(model->PK2SAT_Given == FALSE) model->PK2SAT=0.0;
    if(model->LK2SAT1_Given == FALSE) model->LK2SAT1=0.0;
    if(model->NK2SAT1_Given == FALSE) model->NK2SAT1=0.0;
    if(model->PK2SAT1_Given == FALSE) model->PK2SAT1=0.0;
    if(model->LK2_Given == FALSE) model->LK2=0.0;
    if(model->NK2_Given == FALSE) model->NK2=0.0;
    if(model->PK2_Given == FALSE) model->PK2=0.0;
    if(model->LK21_Given == FALSE) model->LK21=0.0;
    if(model->NK21_Given == FALSE) model->NK21=0.0;
    if(model->PK21_Given == FALSE) model->PK21=0.0;
    if(model->LDVTB_Given == FALSE) model->LDVTB=0.0;
    if(model->NDVTB_Given == FALSE) model->NDVTB=0.0;
    if(model->PDVTB_Given == FALSE) model->PDVTB=0.0;
    if(model->LLPEB_Given == FALSE) model->LLPEB=0.0;
    if(model->NLPEB_Given == FALSE) model->NLPEB=0.0;
    if(model->PLPEB_Given == FALSE) model->PLPEB=0.0;
    if(model->LQMFACTOR_Given == FALSE) model->LQMFACTOR=0.0;
    if(model->NQMFACTOR_Given == FALSE) model->NQMFACTOR=0.0;
    if(model->PQMFACTOR_Given == FALSE) model->PQMFACTOR=0.0;
    if(model->LQMTCENCV_Given == FALSE) model->LQMTCENCV=0.0;
    if(model->NQMTCENCV_Given == FALSE) model->NQMTCENCV=0.0;
    if(model->PQMTCENCV_Given == FALSE) model->PQMTCENCV=0.0;
    if(model->LQMTCENCVA_Given == FALSE) model->LQMTCENCVA=0.0;
    if(model->NQMTCENCVA_Given == FALSE) model->NQMTCENCVA=0.0;
    if(model->PQMTCENCVA_Given == FALSE) model->PQMTCENCVA=0.0;
    if(model->LVSAT_Given == FALSE) model->LVSAT=0.0;
    if(model->NVSAT_Given == FALSE) model->NVSAT=0.0;
    if(model->PVSAT_Given == FALSE) model->PVSAT=0.0;
    if(model->LVSATR_Given == FALSE) model->LVSATR=model->LVSAT;
    if(model->NVSATR_Given == FALSE) model->NVSATR=model->NVSAT;
    if(model->PVSATR_Given == FALSE) model->PVSATR=model->PVSAT;
    if(model->LVSAT1_Given == FALSE) model->LVSAT1=model->LVSAT;
    if(model->NVSAT1_Given == FALSE) model->NVSAT1=model->NVSAT;
    if(model->PVSAT1_Given == FALSE) model->PVSAT1=model->PVSAT;
    if(model->LVSAT1R_Given == FALSE) model->LVSAT1R=model->LVSAT1;
    if(model->NVSAT1R_Given == FALSE) model->NVSAT1R=model->NVSAT1;
    if(model->PVSAT1R_Given == FALSE) model->PVSAT1R=model->PVSAT1;
    if(model->LPSAT_Given == FALSE) model->LPSAT=0.0;
    if(model->NPSAT_Given == FALSE) model->NPSAT=0.0;
    if(model->PPSAT_Given == FALSE) model->PPSAT=0.0;
    if(model->LDELTAVSAT_Given == FALSE) model->LDELTAVSAT=0.0;
    if(model->NDELTAVSAT_Given == FALSE) model->NDELTAVSAT=0.0;
    if(model->PDELTAVSAT_Given == FALSE) model->PDELTAVSAT=0.0;
    if(model->LKSATIV_Given == FALSE) model->LKSATIV=0.0;
    if(model->NKSATIV_Given == FALSE) model->NKSATIV=0.0;
    if(model->PKSATIV_Given == FALSE) model->PKSATIV=0.0;
    if(model->LKSATIVR_Given == FALSE) model->LKSATIVR=model->LKSATIV;
    if(model->NKSATIVR_Given == FALSE) model->NKSATIVR=model->NKSATIV;
    if(model->PKSATIVR_Given == FALSE) model->PKSATIVR=model->PKSATIV;
    if(model->LVSATCV_Given == FALSE) model->LVSATCV=0.0;
    if(model->NVSATCV_Given == FALSE) model->NVSATCV=0.0;
    if(model->PVSATCV_Given == FALSE) model->PVSATCV=0.0;
    if(model->LPSATCV_Given == FALSE) model->LPSATCV=0.0;
    if(model->NPSATCV_Given == FALSE) model->NPSATCV=0.0;
    if(model->PPSATCV_Given == FALSE) model->PPSATCV=0.0;
    if(model->LDELTAVSATCV_Given == FALSE) model->LDELTAVSATCV=0.0;
    if(model->NDELTAVSATCV_Given == FALSE) model->NDELTAVSATCV=0.0;
    if(model->PDELTAVSATCV_Given == FALSE) model->PDELTAVSATCV=0.0;
    if(model->LMEXP_Given == FALSE) model->LMEXP=0.0;
    if(model->NMEXP_Given == FALSE) model->NMEXP=0.0;
    if(model->PMEXP_Given == FALSE) model->PMEXP=0.0;
    if(model->LMEXPR_Given == FALSE) model->LMEXPR=model->LMEXP;
    if(model->NMEXPR_Given == FALSE) model->NMEXPR=model->NMEXP;
    if(model->PMEXPR_Given == FALSE) model->PMEXPR=model->PMEXP;
    if(model->LPTWG_Given == FALSE) model->LPTWG=0.0;
    if(model->NPTWG_Given == FALSE) model->NPTWG=0.0;
    if(model->PPTWG_Given == FALSE) model->PPTWG=0.0;
    if(model->LPTWGR_Given == FALSE) model->LPTWGR=model->LPTWG;
    if(model->NPTWGR_Given == FALSE) model->NPTWGR=model->NPTWG;
    if(model->PPTWGR_Given == FALSE) model->PPTWGR=model->PPTWG;
    if(model->LU0_Given == FALSE) model->LU0=0.0;
    if(model->NU0_Given == FALSE) model->NU0=0.0;
    if(model->PU0_Given == FALSE) model->PU0=0.0;
    if(model->LU0R_Given == FALSE) model->LU0R=model->LU0;
    if(model->NU0R_Given == FALSE) model->NU0R=model->NU0;
    if(model->PU0R_Given == FALSE) model->PU0R=model->PU0;
    if(model->LETAMOB_Given == FALSE) model->LETAMOB=0.0;
    if(model->NETAMOB_Given == FALSE) model->NETAMOB=0.0;
    if(model->PETAMOB_Given == FALSE) model->PETAMOB=0.0;
    if(model->LUP_Given == FALSE) model->LUP=0.0;
    if(model->NUP_Given == FALSE) model->NUP=0.0;
    if(model->PUP_Given == FALSE) model->PUP=0.0;
    if(model->LUPR_Given == FALSE) model->LUPR=model->LUP;
    if(model->NUPR_Given == FALSE) model->NUPR=model->NUP;
    if(model->PUPR_Given == FALSE) model->PUPR=model->PUP;
    if(model->LUA_Given == FALSE) model->LUA=0.0;
    if(model->NUA_Given == FALSE) model->NUA=0.0;
    if(model->PUA_Given == FALSE) model->PUA=0.0;
    if(model->LUAR_Given == FALSE) model->LUAR=model->LUA;
    if(model->NUAR_Given == FALSE) model->NUAR=model->NUA;
    if(model->PUAR_Given == FALSE) model->PUAR=model->PUA;
    if(model->LUC_Given == FALSE) model->LUC=0.0;
    if(model->NUC_Given == FALSE) model->NUC=0.0;
    if(model->PUC_Given == FALSE) model->PUC=0.0;
    if(model->LUCR_Given == FALSE) model->LUCR=model->LUC;
    if(model->NUCR_Given == FALSE) model->NUCR=model->NUC;
    if(model->PUCR_Given == FALSE) model->PUCR=model->PUC;
    if(model->LEU_Given == FALSE) model->LEU=0.0;
    if(model->NEU_Given == FALSE) model->NEU=0.0;
    if(model->PEU_Given == FALSE) model->PEU=0.0;
    if(model->LEUR_Given == FALSE) model->LEUR=model->LEU;
    if(model->NEUR_Given == FALSE) model->NEUR=model->NEU;
    if(model->PEUR_Given == FALSE) model->PEUR=model->PEU;
    if(model->LUD_Given == FALSE) model->LUD=0.0;
    if(model->NUD_Given == FALSE) model->NUD=0.0;
    if(model->PUD_Given == FALSE) model->PUD=0.0;
    if(model->LUDR_Given == FALSE) model->LUDR=model->LUD;
    if(model->NUDR_Given == FALSE) model->NUDR=model->NUD;
    if(model->PUDR_Given == FALSE) model->PUDR=model->PUD;
    if(model->LUCS_Given == FALSE) model->LUCS=0.0;
    if(model->NUCS_Given == FALSE) model->NUCS=0.0;
    if(model->PUCS_Given == FALSE) model->PUCS=0.0;
    if(model->LPCLM_Given == FALSE) model->LPCLM=0.0;
    if(model->NPCLM_Given == FALSE) model->NPCLM=0.0;
    if(model->PPCLM_Given == FALSE) model->PPCLM=0.0;
    if(model->LPCLMR_Given == FALSE) model->LPCLMR=model->LPCLM;
    if(model->NPCLMR_Given == FALSE) model->NPCLMR=model->NPCLM;
    if(model->PPCLMR_Given == FALSE) model->PPCLMR=model->PPCLM;
    if(model->LPCLMG_Given == FALSE) model->LPCLMG=0.0;
    if(model->NPCLMG_Given == FALSE) model->NPCLMG=0.0;
    if(model->PPCLMG_Given == FALSE) model->PPCLMG=0.0;
    if(model->LPCLMCV_Given == FALSE) model->LPCLMCV=model->LPCLM;
    if(model->NPCLMCV_Given == FALSE) model->NPCLMCV=model->NPCLM;
    if(model->PPCLMCV_Given == FALSE) model->PPCLMCV=model->PPCLM;
    if(model->LA1_Given == FALSE) model->LA1=0.0;
    if(model->NA1_Given == FALSE) model->NA1=0.0;
    if(model->PA1_Given == FALSE) model->PA1=0.0;
    if(model->LA11_Given == FALSE) model->LA11=0.0;
    if(model->NA11_Given == FALSE) model->NA11=0.0;
    if(model->PA11_Given == FALSE) model->PA11=0.0;
    if(model->LA2_Given == FALSE) model->LA2=0.0;
    if(model->NA2_Given == FALSE) model->NA2=0.0;
    if(model->PA2_Given == FALSE) model->PA2=0.0;
    if(model->LA21_Given == FALSE) model->LA21=0.0;
    if(model->NA21_Given == FALSE) model->NA21=0.0;
    if(model->PA21_Given == FALSE) model->PA21=0.0;
    if(model->LRDSW_Given == FALSE) model->LRDSW=0.0;
    if(model->NRDSW_Given == FALSE) model->NRDSW=0.0;
    if(model->PRDSW_Given == FALSE) model->PRDSW=0.0;
    if(model->LRSW_Given == FALSE) model->LRSW=0.0;
    if(model->NRSW_Given == FALSE) model->NRSW=0.0;
    if(model->PRSW_Given == FALSE) model->PRSW=0.0;
    if(model->LRDW_Given == FALSE) model->LRDW=0.0;
    if(model->NRDW_Given == FALSE) model->NRDW=0.0;
    if(model->PRDW_Given == FALSE) model->PRDW=0.0;
    if(model->LPRWGS_Given == FALSE) model->LPRWGS=0.0;
    if(model->NPRWGS_Given == FALSE) model->NPRWGS=0.0;
    if(model->PPRWGS_Given == FALSE) model->PPRWGS=0.0;
    if(model->LPRWGD_Given == FALSE) model->LPRWGD=0.0;
    if(model->NPRWGD_Given == FALSE) model->NPRWGD=0.0;
    if(model->PPRWGD_Given == FALSE) model->PPRWGD=0.0;
    if(model->LWR_Given == FALSE) model->LWR=0.0;
    if(model->NWR_Given == FALSE) model->NWR=0.0;
    if(model->PWR_Given == FALSE) model->PWR=0.0;
    if(model->LPDIBL1_Given == FALSE) model->LPDIBL1=0.0;
    if(model->NPDIBL1_Given == FALSE) model->NPDIBL1=0.0;
    if(model->PPDIBL1_Given == FALSE) model->PPDIBL1=0.0;
    if(model->LPDIBL1R_Given == FALSE) model->LPDIBL1R=model->LPDIBL1;
    if(model->NPDIBL1R_Given == FALSE) model->NPDIBL1R=model->NPDIBL1;
    if(model->PPDIBL1R_Given == FALSE) model->PPDIBL1R=model->PPDIBL1;
    if(model->LPDIBL2_Given == FALSE) model->LPDIBL2=0.0;
    if(model->NPDIBL2_Given == FALSE) model->NPDIBL2=0.0;
    if(model->PPDIBL2_Given == FALSE) model->PPDIBL2=0.0;
    if(model->LPDIBL2R_Given == FALSE) model->LPDIBL2R=model->LPDIBL2;
    if(model->NPDIBL2R_Given == FALSE) model->NPDIBL2R=model->NPDIBL2;
    if(model->PPDIBL2R_Given == FALSE) model->PPDIBL2R=model->PPDIBL2;
    if(model->LDROUT_Given == FALSE) model->LDROUT=0.0;
    if(model->NDROUT_Given == FALSE) model->NDROUT=0.0;
    if(model->PDROUT_Given == FALSE) model->PDROUT=0.0;
    if(model->LPVAG_Given == FALSE) model->LPVAG=0.0;
    if(model->NPVAG_Given == FALSE) model->NPVAG=0.0;
    if(model->PPVAG_Given == FALSE) model->PPVAG=0.0;
    if(model->LAIGBINV_Given == FALSE) model->LAIGBINV=0.0;
    if(model->NAIGBINV_Given == FALSE) model->NAIGBINV=0.0;
    if(model->PAIGBINV_Given == FALSE) model->PAIGBINV=0.0;
    if(model->LAIGBINV1_Given == FALSE) model->LAIGBINV1=0.0;
    if(model->NAIGBINV1_Given == FALSE) model->NAIGBINV1=0.0;
    if(model->PAIGBINV1_Given == FALSE) model->PAIGBINV1=0.0;
    if(model->LBIGBINV_Given == FALSE) model->LBIGBINV=0.0;
    if(model->NBIGBINV_Given == FALSE) model->NBIGBINV=0.0;
    if(model->PBIGBINV_Given == FALSE) model->PBIGBINV=0.0;
    if(model->LCIGBINV_Given == FALSE) model->LCIGBINV=0.0;
    if(model->NCIGBINV_Given == FALSE) model->NCIGBINV=0.0;
    if(model->PCIGBINV_Given == FALSE) model->PCIGBINV=0.0;
    if(model->LEIGBINV_Given == FALSE) model->LEIGBINV=0.0;
    if(model->NEIGBINV_Given == FALSE) model->NEIGBINV=0.0;
    if(model->PEIGBINV_Given == FALSE) model->PEIGBINV=0.0;
    if(model->LNIGBINV_Given == FALSE) model->LNIGBINV=0.0;
    if(model->NNIGBINV_Given == FALSE) model->NNIGBINV=0.0;
    if(model->PNIGBINV_Given == FALSE) model->PNIGBINV=0.0;
    if(model->LAIGBACC_Given == FALSE) model->LAIGBACC=0.0;
    if(model->NAIGBACC_Given == FALSE) model->NAIGBACC=0.0;
    if(model->PAIGBACC_Given == FALSE) model->PAIGBACC=0.0;
    if(model->LAIGBACC1_Given == FALSE) model->LAIGBACC1=0.0;
    if(model->NAIGBACC1_Given == FALSE) model->NAIGBACC1=0.0;
    if(model->PAIGBACC1_Given == FALSE) model->PAIGBACC1=0.0;
    if(model->LBIGBACC_Given == FALSE) model->LBIGBACC=0.0;
    if(model->NBIGBACC_Given == FALSE) model->NBIGBACC=0.0;
    if(model->PBIGBACC_Given == FALSE) model->PBIGBACC=0.0;
    if(model->LCIGBACC_Given == FALSE) model->LCIGBACC=0.0;
    if(model->NCIGBACC_Given == FALSE) model->NCIGBACC=0.0;
    if(model->PCIGBACC_Given == FALSE) model->PCIGBACC=0.0;
    if(model->LNIGBACC_Given == FALSE) model->LNIGBACC=0.0;
    if(model->NNIGBACC_Given == FALSE) model->NNIGBACC=0.0;
    if(model->PNIGBACC_Given == FALSE) model->PNIGBACC=0.0;
    if(model->LAIGC_Given == FALSE) model->LAIGC=0.0;
    if(model->NAIGC_Given == FALSE) model->NAIGC=0.0;
    if(model->PAIGC_Given == FALSE) model->PAIGC=0.0;
    if(model->LAIGC1_Given == FALSE) model->LAIGC1=0.0;
    if(model->NAIGC1_Given == FALSE) model->NAIGC1=0.0;
    if(model->PAIGC1_Given == FALSE) model->PAIGC1=0.0;
    if(model->LBIGC_Given == FALSE) model->LBIGC=0.0;
    if(model->NBIGC_Given == FALSE) model->NBIGC=0.0;
    if(model->PBIGC_Given == FALSE) model->PBIGC=0.0;
    if(model->LCIGC_Given == FALSE) model->LCIGC=0.0;
    if(model->NCIGC_Given == FALSE) model->NCIGC=0.0;
    if(model->PCIGC_Given == FALSE) model->PCIGC=0.0;
    if(model->LPIGCD_Given == FALSE) model->LPIGCD=0.0;
    if(model->NPIGCD_Given == FALSE) model->NPIGCD=0.0;
    if(model->PPIGCD_Given == FALSE) model->PPIGCD=0.0;
    if(model->LAIGS_Given == FALSE) model->LAIGS=0.0;
    if(model->NAIGS_Given == FALSE) model->NAIGS=0.0;
    if(model->PAIGS_Given == FALSE) model->PAIGS=0.0;
    if(model->LAIGS1_Given == FALSE) model->LAIGS1=0.0;
    if(model->NAIGS1_Given == FALSE) model->NAIGS1=0.0;
    if(model->PAIGS1_Given == FALSE) model->PAIGS1=0.0;
    if(model->LBIGS_Given == FALSE) model->LBIGS=0.0;
    if(model->NBIGS_Given == FALSE) model->NBIGS=0.0;
    if(model->PBIGS_Given == FALSE) model->PBIGS=0.0;
    if(model->LCIGS_Given == FALSE) model->LCIGS=0.0;
    if(model->NCIGS_Given == FALSE) model->NCIGS=0.0;
    if(model->PCIGS_Given == FALSE) model->PCIGS=0.0;
    if(model->LAIGD_Given == FALSE) model->LAIGD=model->LAIGS;
    if(model->NAIGD_Given == FALSE) model->NAIGD=model->NAIGS;
    if(model->PAIGD_Given == FALSE) model->PAIGD=model->PAIGS;
    if(model->LAIGD1_Given == FALSE) model->LAIGD1=model->LAIGS1;
    if(model->NAIGD1_Given == FALSE) model->NAIGD1=model->NAIGS1;
    if(model->PAIGD1_Given == FALSE) model->PAIGD1=model->PAIGS1;
    if(model->LBIGD_Given == FALSE) model->LBIGD=model->LBIGS;
    if(model->NBIGD_Given == FALSE) model->NBIGD=model->NBIGS;
    if(model->PBIGD_Given == FALSE) model->PBIGD=model->PBIGS;
    if(model->LCIGD_Given == FALSE) model->LCIGD=model->LCIGS;
    if(model->NCIGD_Given == FALSE) model->NCIGD=model->NCIGS;
    if(model->PCIGD_Given == FALSE) model->PCIGD=model->PCIGS;
    if(model->LNTOX_Given == FALSE) model->LNTOX=0.0;
    if(model->NNTOX_Given == FALSE) model->NNTOX=0.0;
    if(model->PNTOX_Given == FALSE) model->PNTOX=0.0;
    if(model->LPOXEDGE_Given == FALSE) model->LPOXEDGE=0.0;
    if(model->NPOXEDGE_Given == FALSE) model->NPOXEDGE=0.0;
    if(model->PPOXEDGE_Given == FALSE) model->PPOXEDGE=0.0;
    if(model->LAGISL_Given == FALSE) model->LAGISL=0.0;
    if(model->NAGISL_Given == FALSE) model->NAGISL=0.0;
    if(model->PAGISL_Given == FALSE) model->PAGISL=0.0;
    if(model->LBGISL_Given == FALSE) model->LBGISL=0.0;
    if(model->NBGISL_Given == FALSE) model->NBGISL=0.0;
    if(model->PBGISL_Given == FALSE) model->PBGISL=0.0;
    if(model->LCGISL_Given == FALSE) model->LCGISL=0.0;
    if(model->NCGISL_Given == FALSE) model->NCGISL=0.0;
    if(model->PCGISL_Given == FALSE) model->PCGISL=0.0;
    if(model->LEGISL_Given == FALSE) model->LEGISL=0.0;
    if(model->NEGISL_Given == FALSE) model->NEGISL=0.0;
    if(model->PEGISL_Given == FALSE) model->PEGISL=0.0;
    if(model->LPGISL_Given == FALSE) model->LPGISL=0.0;
    if(model->NPGISL_Given == FALSE) model->NPGISL=0.0;
    if(model->PPGISL_Given == FALSE) model->PPGISL=0.0;
    if(model->LAGIDL_Given == FALSE) model->LAGIDL=model->LAGISL;
    if(model->NAGIDL_Given == FALSE) model->NAGIDL=model->NAGISL;
    if(model->PAGIDL_Given == FALSE) model->PAGIDL=model->PAGISL;
    if(model->LBGIDL_Given == FALSE) model->LBGIDL=model->LBGISL;
    if(model->NBGIDL_Given == FALSE) model->NBGIDL=model->NBGISL;
    if(model->PBGIDL_Given == FALSE) model->PBGIDL=model->PBGISL;
    if(model->LCGIDL_Given == FALSE) model->LCGIDL=model->LCGISL;
    if(model->NCGIDL_Given == FALSE) model->NCGIDL=model->NCGISL;
    if(model->PCGIDL_Given == FALSE) model->PCGIDL=model->PCGISL;
    if(model->LEGIDL_Given == FALSE) model->LEGIDL=model->LEGISL;
    if(model->NEGIDL_Given == FALSE) model->NEGIDL=model->NEGISL;
    if(model->PEGIDL_Given == FALSE) model->PEGIDL=model->PEGISL;
    if(model->LPGIDL_Given == FALSE) model->LPGIDL=model->LPGISL;
    if(model->NPGIDL_Given == FALSE) model->NPGIDL=model->NPGISL;
    if(model->PPGIDL_Given == FALSE) model->PPGIDL=model->PPGISL;
    if(model->LALPHA0_Given == FALSE) model->LALPHA0=0.0;
    if(model->NALPHA0_Given == FALSE) model->NALPHA0=0.0;
    if(model->PALPHA0_Given == FALSE) model->PALPHA0=0.0;
    if(model->LALPHA1_Given == FALSE) model->LALPHA1=0.0;
    if(model->NALPHA1_Given == FALSE) model->NALPHA1=0.0;
    if(model->PALPHA1_Given == FALSE) model->PALPHA1=0.0;
    if(model->LALPHAII0_Given == FALSE) model->LALPHAII0=0.0;
    if(model->NALPHAII0_Given == FALSE) model->NALPHAII0=0.0;
    if(model->PALPHAII0_Given == FALSE) model->PALPHAII0=0.0;
    if(model->LALPHAII1_Given == FALSE) model->LALPHAII1=0.0;
    if(model->NALPHAII1_Given == FALSE) model->NALPHAII1=0.0;
    if(model->PALPHAII1_Given == FALSE) model->PALPHAII1=0.0;
    if(model->LBETA0_Given == FALSE) model->LBETA0=0.0;
    if(model->NBETA0_Given == FALSE) model->NBETA0=0.0;
    if(model->PBETA0_Given == FALSE) model->PBETA0=0.0;
    if(model->LBETAII0_Given == FALSE) model->LBETAII0=0.0;
    if(model->NBETAII0_Given == FALSE) model->NBETAII0=0.0;
    if(model->PBETAII0_Given == FALSE) model->PBETAII0=0.0;
    if(model->LBETAII1_Given == FALSE) model->LBETAII1=0.0;
    if(model->NBETAII1_Given == FALSE) model->NBETAII1=0.0;
    if(model->PBETAII1_Given == FALSE) model->PBETAII1=0.0;
    if(model->LBETAII2_Given == FALSE) model->LBETAII2=0.0;
    if(model->NBETAII2_Given == FALSE) model->NBETAII2=0.0;
    if(model->PBETAII2_Given == FALSE) model->PBETAII2=0.0;
    if(model->LESATII_Given == FALSE) model->LESATII=0.0;
    if(model->NESATII_Given == FALSE) model->NESATII=0.0;
    if(model->PESATII_Given == FALSE) model->PESATII=0.0;
    if(model->LLII_Given == FALSE) model->LLII=0.0;
    if(model->NLII_Given == FALSE) model->NLII=0.0;
    if(model->PLII_Given == FALSE) model->PLII=0.0;
    if(model->LSII0_Given == FALSE) model->LSII0=0.0;
    if(model->NSII0_Given == FALSE) model->NSII0=0.0;
    if(model->PSII0_Given == FALSE) model->PSII0=0.0;
    if(model->LSII1_Given == FALSE) model->LSII1=0.0;
    if(model->NSII1_Given == FALSE) model->NSII1=0.0;
    if(model->PSII1_Given == FALSE) model->PSII1=0.0;
    if(model->LSII2_Given == FALSE) model->LSII2=0.0;
    if(model->NSII2_Given == FALSE) model->NSII2=0.0;
    if(model->PSII2_Given == FALSE) model->PSII2=0.0;
    if(model->LSIID_Given == FALSE) model->LSIID=0.0;
    if(model->NSIID_Given == FALSE) model->NSIID=0.0;
    if(model->PSIID_Given == FALSE) model->PSIID=0.0;
    if(model->LCFS_Given == FALSE) model->LCFS=0.0;
    if(model->NCFS_Given == FALSE) model->NCFS=0.0;
    if(model->PCFS_Given == FALSE) model->PCFS=0.0;
    if(model->LCFD_Given == FALSE) model->LCFD=model->LCFS;
    if(model->NCFD_Given == FALSE) model->NCFD=model->NCFS;
    if(model->PCFD_Given == FALSE) model->PCFD=model->PCFS;
    if(model->LCOVS_Given == FALSE) model->LCOVS=0.0;
    if(model->NCOVS_Given == FALSE) model->NCOVS=0.0;
    if(model->PCOVS_Given == FALSE) model->PCOVS=0.0;
    if(model->LCOVD_Given == FALSE) model->LCOVD=model->LCOVS;
    if(model->NCOVD_Given == FALSE) model->NCOVD=model->NCOVS;
    if(model->PCOVD_Given == FALSE) model->PCOVD=model->PCOVS;
    if(model->LCGSL_Given == FALSE) model->LCGSL=0.0;
    if(model->NCGSL_Given == FALSE) model->NCGSL=0.0;
    if(model->PCGSL_Given == FALSE) model->PCGSL=0.0;
    if(model->LCGDL_Given == FALSE) model->LCGDL=model->LCGSL;
    if(model->NCGDL_Given == FALSE) model->NCGDL=model->NCGSL;
    if(model->PCGDL_Given == FALSE) model->PCGDL=model->PCGSL;
    if(model->LCKAPPAS_Given == FALSE) model->LCKAPPAS=0.0;
    if(model->NCKAPPAS_Given == FALSE) model->NCKAPPAS=0.0;
    if(model->PCKAPPAS_Given == FALSE) model->PCKAPPAS=0.0;
    if(model->LCKAPPAD_Given == FALSE) model->LCKAPPAD=model->LCKAPPAS;
    if(model->NCKAPPAD_Given == FALSE) model->NCKAPPAD=model->NCKAPPAS;
    if(model->PCKAPPAD_Given == FALSE) model->PCKAPPAD=model->PCKAPPAS;
    if(model->LCGBL_Given == FALSE) model->LCGBL=0.0;
    if(model->NCGBL_Given == FALSE) model->NCGBL=0.0;
    if(model->PCGBL_Given == FALSE) model->PCGBL=0.0;
    if(model->LCKAPPAB_Given == FALSE) model->LCKAPPAB=0.0;
    if(model->NCKAPPAB_Given == FALSE) model->NCKAPPAB=0.0;
    if(model->PCKAPPAB_Given == FALSE) model->PCKAPPAB=0.0;
    if(model->LNTGEN_Given == FALSE) model->LNTGEN=0.0;
    if(model->NNTGEN_Given == FALSE) model->NNTGEN=0.0;
    if(model->PNTGEN_Given == FALSE) model->PNTGEN=0.0;
    if(model->LAIGEN_Given == FALSE) model->LAIGEN=0.0;
    if(model->NAIGEN_Given == FALSE) model->NAIGEN=0.0;
    if(model->PAIGEN_Given == FALSE) model->PAIGEN=0.0;
    if(model->LBIGEN_Given == FALSE) model->LBIGEN=0.0;
    if(model->NBIGEN_Given == FALSE) model->NBIGEN=0.0;
    if(model->PBIGEN_Given == FALSE) model->PBIGEN=0.0;
    if(model->LXRCRG1_Given == FALSE) model->LXRCRG1=0.0;
    if(model->NXRCRG1_Given == FALSE) model->NXRCRG1=0.0;
    if(model->PXRCRG1_Given == FALSE) model->PXRCRG1=0.0;
    if(model->LXRCRG2_Given == FALSE) model->LXRCRG2=0.0;
    if(model->NXRCRG2_Given == FALSE) model->NXRCRG2=0.0;
    if(model->PXRCRG2_Given == FALSE) model->PXRCRG2=0.0;
    if(model->LUTE_Given == FALSE) model->LUTE=0.0;
    if(model->NUTE_Given == FALSE) model->NUTE=0.0;
    if(model->PUTE_Given == FALSE) model->PUTE=0.0;
    if(model->LUTER_Given == FALSE) model->LUTER=model->LUTE;
    if(model->NUTER_Given == FALSE) model->NUTER=model->NUTE;
    if(model->PUTER_Given == FALSE) model->PUTER=model->PUTE;
    if(model->LUTL_Given == FALSE) model->LUTL=0.0;
    if(model->NUTL_Given == FALSE) model->NUTL=0.0;
    if(model->PUTL_Given == FALSE) model->PUTL=0.0;
    if(model->LUTLR_Given == FALSE) model->LUTLR=model->LUTL;
    if(model->NUTLR_Given == FALSE) model->NUTLR=model->NUTL;
    if(model->PUTLR_Given == FALSE) model->PUTLR=model->PUTL;
    if(model->LEMOBT_Given == FALSE) model->LEMOBT=0.0;
    if(model->NEMOBT_Given == FALSE) model->NEMOBT=0.0;
    if(model->PEMOBT_Given == FALSE) model->PEMOBT=0.0;
    if(model->LUA1_Given == FALSE) model->LUA1=0.0;
    if(model->NUA1_Given == FALSE) model->NUA1=0.0;
    if(model->PUA1_Given == FALSE) model->PUA1=0.0;
    if(model->LUA1R_Given == FALSE) model->LUA1R=model->LUA1;
    if(model->NUA1R_Given == FALSE) model->NUA1R=model->NUA1;
    if(model->PUA1R_Given == FALSE) model->PUA1R=model->PUA1;
    if(model->LUC1_Given == FALSE) model->LUC1=0.0;
    if(model->NUC1_Given == FALSE) model->NUC1=0.0;
    if(model->PUC1_Given == FALSE) model->PUC1=0.0;
    if(model->LUC1R_Given == FALSE) model->LUC1R=model->LUC1;
    if(model->NUC1R_Given == FALSE) model->NUC1R=model->NUC1;
    if(model->PUC1R_Given == FALSE) model->PUC1R=model->PUC1;
    if(model->LUD1_Given == FALSE) model->LUD1=0.0;
    if(model->NUD1_Given == FALSE) model->NUD1=0.0;
    if(model->PUD1_Given == FALSE) model->PUD1=0.0;
    if(model->LUD1R_Given == FALSE) model->LUD1R=model->LUD1;
    if(model->NUD1R_Given == FALSE) model->NUD1R=model->NUD1;
    if(model->PUD1R_Given == FALSE) model->PUD1R=model->PUD1;
    if(model->LUCSTE_Given == FALSE) model->LUCSTE=0.0;
    if(model->NUCSTE_Given == FALSE) model->NUCSTE=0.0;
    if(model->PUCSTE_Given == FALSE) model->PUCSTE=0.0;
    if(model->LPTWGT_Given == FALSE) model->LPTWGT=0.0;
    if(model->NPTWGT_Given == FALSE) model->NPTWGT=0.0;
    if(model->PPTWGT_Given == FALSE) model->PPTWGT=0.0;
    if(model->LAT_Given == FALSE) model->LAT=0.0;
    if(model->NAT_Given == FALSE) model->NAT=0.0;
    if(model->PAT_Given == FALSE) model->PAT=0.0;
    if(model->LATR_Given == FALSE) model->LATR=model->LAT;
    if(model->NATR_Given == FALSE) model->NATR=model->NAT;
    if(model->PATR_Given == FALSE) model->PATR=model->PAT;
    if(model->LATCV_Given == FALSE) model->LATCV=0.0;
    if(model->NATCV_Given == FALSE) model->NATCV=0.0;
    if(model->PATCV_Given == FALSE) model->PATCV=0.0;
    if(model->LSTTHETASAT_Given == FALSE) model->LSTTHETASAT=0.0;
    if(model->NSTTHETASAT_Given == FALSE) model->NSTTHETASAT=0.0;
    if(model->PSTTHETASAT_Given == FALSE) model->PSTTHETASAT=0.0;
    if(model->LPRT_Given == FALSE) model->LPRT=0.0;
    if(model->NPRT_Given == FALSE) model->NPRT=0.0;
    if(model->PPRT_Given == FALSE) model->PPRT=0.0;
    if(model->LKT1_Given == FALSE) model->LKT1=0.0;
    if(model->NKT1_Given == FALSE) model->NKT1=0.0;
    if(model->PKT1_Given == FALSE) model->PKT1=0.0;
    if(model->LTSS_Given == FALSE) model->LTSS=0.0;
    if(model->NTSS_Given == FALSE) model->NTSS=0.0;
    if(model->PTSS_Given == FALSE) model->PTSS=0.0;
    if(model->LIIT_Given == FALSE) model->LIIT=0.0;
    if(model->NIIT_Given == FALSE) model->NIIT=0.0;
    if(model->PIIT_Given == FALSE) model->PIIT=0.0;
    if(model->LTII_Given == FALSE) model->LTII=0.0;
    if(model->NTII_Given == FALSE) model->NTII=0.0;
    if(model->PTII_Given == FALSE) model->PTII=0.0;
    if(model->LTGIDL_Given == FALSE) model->LTGIDL=0.0;
    if(model->NTGIDL_Given == FALSE) model->NTGIDL=0.0;
    if(model->PTGIDL_Given == FALSE) model->PTGIDL=0.0;
    if(model->LIGT_Given == FALSE) model->LIGT=0.0;
    if(model->NIGT_Given == FALSE) model->NIGT=0.0;
    if(model->PIGT_Given == FALSE) model->PIGT=0.0;
    for ( here = bsimcmginstances(model) ;here != NULL ; here = bsimcmgnextInstance(here) )
    {
    if(here->L_Given == FALSE) here->L=3.0e-8;
    if(here->D_Given == FALSE) here->D=4.0e-8;
    if(here->TFIN_Given == FALSE) here->TFIN=1.5e-8;
    if(here->FPITCH_Given == FALSE) here->FPITCH=8.0e-8;
    if(here->NF_Given == FALSE) here->NF=1;
    if(here->NFIN_Given == FALSE) here->NFIN=1.0;
    if(here->NGCON_Given == FALSE) here->NGCON=1;
    if(here->ASEO_Given == FALSE) here->ASEO=0.0;
    if(here->ADEO_Given == FALSE) here->ADEO=0.0;
    if(here->PSEO_Given == FALSE) here->PSEO=0.0;
    if(here->PDEO_Given == FALSE) here->PDEO=0.0;
    if(here->ASEJ_Given == FALSE) here->ASEJ=0.0;
    if(here->ADEJ_Given == FALSE) here->ADEJ=0.0;
    if(here->PSEJ_Given == FALSE) here->PSEJ=0.0;
    if(here->PDEJ_Given == FALSE) here->PDEJ=0.0;
    if(here->COVS_Given == FALSE) here->COVS=0.0;
    if(here->COVD_Given == FALSE) here->COVD=here->COVS;
    if(here->CGSP_Given == FALSE) here->CGSP=0.0;
    if(here->CGDP_Given == FALSE) here->CGDP=0.0;
    if(here->CDSP_Given == FALSE) here->CDSP=0.0;
    if(here->NRS_Given == FALSE) here->NRS=0.0;
    if(here->NRD_Given == FALSE) here->NRD=0.0;
    if(here->LRSD_Given == FALSE) here->LRSD=here->L;
    if(here->NFINNOM_Given == FALSE) here->NFINNOM=1.0;
      /* External Nodes, connected ? */
      here->dNode_connected = (here->dNode >= 0);
      here->gNode_connected = (here->gNode >= 0);
      here->sNode_connected = (here->sNode >= 0);
      here->eNode_connected = (here->eNode >= 0);
      here->tNode_connected = (here->tNode >= 0);
      /* Internal Nodes */
      {
        here->siNode = -1;
        here->siNode_mine = 0;
        here->diNode = -1;
        here->diNode_mine = 0;
        here->geNode = -1;
        here->geNode_mine = 0;
        here->NNode = -1;
        here->NNode_mine = 0;
      }
       ((GENinstance*)here)->GENstate = *states;
       *states += bsimcmgnumStates;
      /* set states */
      here->state_t_GND = *states; *states += 2;
      here->state_ge_d = *states; *states += 2;
      here->state_ge_s = *states; *states += 2;
      here->state_d_s = *states; *states += 2;
      here->state_e_ge = *states; *states += 2;
      here->state_e_di = *states; *states += 2;
      here->state_e_si = *states; *states += 2;
      here->state_ge_di = *states; *states += 2;
      here->state_ge_si = *states; *states += 2;
      here->state_di_si = *states; *states += 2;
      /* set Sparse Matrix Pointers */
      here->PTR_J_di_ge_required=0;
      here->PTR_J_di_di_required=0;
      here->PTR_J_si_ge_required=0;
      here->PTR_J_si_di_required=0;
      here->PTR_J_di_si_required=0;
      here->PTR_J_si_si_required=0;
      here->PTR_J_di_e_required=0;
      here->PTR_J_si_e_required=0;
      here->PTR_J_di_t_required=0;
      here->PTR_J_si_t_required=0;
      here->PTR_J_ge_ge_required=0;
      here->PTR_J_ge_e_required=0;
      here->PTR_J_ge_t_required=0;
      here->PTR_J_ge_si_required=0;
      here->PTR_J_ge_di_required=0;
      here->PTR_J_ge_s_required=0;
      here->PTR_J_si_s_required=0;
      here->PTR_J_ge_d_required=0;
      here->PTR_J_si_d_required=0;
      here->PTR_J_di_s_required=0;
      here->PTR_J_di_d_required=0;
      here->PTR_J_e_ge_required=0;
      here->PTR_J_e_si_required=0;
      here->PTR_J_e_e_required=0;
      here->PTR_J_e_di_required=0;
      here->PTR_J_e_t_required=0;
      here->PTR_J_e_s_required=0;
      here->PTR_J_e_d_required=0;
      here->PTR_J_d_d_required=0;
      here->PTR_J_d_s_required=0;
      here->PTR_J_s_d_required=0;
      here->PTR_J_s_s_required=0;
      here->PTR_J_s_t_required=0;
      here->PTR_J_s_di_required=0;
      here->PTR_J_s_si_required=0;
      here->PTR_J_s_ge_required=0;
      here->PTR_J_s_e_required=0;
      here->PTR_J_d_t_required=0;
      here->PTR_J_d_di_required=0;
      here->PTR_J_d_si_required=0;
      here->PTR_J_d_ge_required=0;
      here->PTR_J_d_e_required=0;
      here->PTR_J_g_g_required=0;
      here->PTR_J_g_ge_required=0;
      here->PTR_J_ge_g_required=0;
      here->PTR_J_g_t_required=0;
      here->PTR_J_di_N_required=0;
      here->PTR_J_si_N_required=0;
      here->PTR_J_N_ge_required=0;
      here->PTR_J_N_e_required=0;
      here->PTR_J_N_si_required=0;
      here->PTR_J_N_s_required=0;
      here->PTR_J_N_di_required=0;
      here->PTR_J_N_d_required=0;
      here->PTR_J_N_t_required=0;
      here->PTR_J_N_N_required=0;
      here->PTR_J_ge_N_required=0;
      here->PTR_J_t_s_required=0;
      here->PTR_J_t_si_required=0;
      here->PTR_J_t_di_required=0;
      here->PTR_J_t_d_required=0;
      here->PTR_J_t_ge_required=0;
      here->PTR_J_t_e_required=0;
      here->PTR_J_t_t_required=0;

      bsimcmgguesstopology(matrix,ckt,model,here);

      /* Internal Nodes */
      {
        int error;
        CKTnode *tmp;
        if(here->dNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XdX");
          if(error) return(error);
          here->dNode = tmp->number;
          here->dNode_mine = 1;
        }
        if(here->gNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XgX");
          if(error) return(error);
          here->gNode = tmp->number;
          here->gNode_mine = 1;
        }
        if(here->sNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XsX");
          if(error) return(error);
          here->sNode = tmp->number;
          here->sNode_mine = 1;
        }
        if(here->eNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XeX");
          if(error) return(error);
          here->eNode = tmp->number;
          here->eNode_mine = 1;
        }
        if(here->tNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XtX");
          if(error) return(error);
          here->tNode = tmp->number;
          here->tNode_mine = 1;
        }
        if(here->siNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XsiX");
          if(error) return(error);
          here->siNode = tmp->number;
          here->siNode_mine = 1;
        }
        if(here->diNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XdiX");
          if(error) return(error);
          here->diNode = tmp->number;
          here->diNode_mine = 1;
        }
        if(here->geNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XgeX");
          if(error) return(error);
          here->geNode = tmp->number;
          here->geNode_mine = 1;
        }
        if(here->NNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->bsimcmgname,"XNX");
          if(error) return(error);
          here->NNode = tmp->number;
          here->NNode_mine = 1;
        }
      }
        if(here->PTR_J_di_ge_required==1)
        {
          here->PTR_J_di_ge=SMPmakeElt(matrix,here->diNode,here->geNode);
        }
        if(here->PTR_J_di_di_required==1)
        {
          here->PTR_J_di_di=SMPmakeElt(matrix,here->diNode,here->diNode);
        }
        if(here->PTR_J_si_ge_required==1)
        {
          here->PTR_J_si_ge=SMPmakeElt(matrix,here->siNode,here->geNode);
        }
        if(here->PTR_J_si_di_required==1)
        {
          here->PTR_J_si_di=SMPmakeElt(matrix,here->siNode,here->diNode);
        }
        if(here->PTR_J_di_si_required==1)
        {
          here->PTR_J_di_si=SMPmakeElt(matrix,here->diNode,here->siNode);
        }
        if(here->PTR_J_si_si_required==1)
        {
          here->PTR_J_si_si=SMPmakeElt(matrix,here->siNode,here->siNode);
        }
        if(here->PTR_J_di_e_required==1)
        {
          here->PTR_J_di_e=SMPmakeElt(matrix,here->diNode,here->eNode);
        }
        if(here->PTR_J_si_e_required==1)
        {
          here->PTR_J_si_e=SMPmakeElt(matrix,here->siNode,here->eNode);
        }
        if(here->PTR_J_di_t_required==1)
        {
          here->PTR_J_di_t=SMPmakeElt(matrix,here->diNode,here->tNode);
        }
        if(here->PTR_J_si_t_required==1)
        {
          here->PTR_J_si_t=SMPmakeElt(matrix,here->siNode,here->tNode);
        }
        if(here->PTR_J_ge_ge_required==1)
        {
          here->PTR_J_ge_ge=SMPmakeElt(matrix,here->geNode,here->geNode);
        }
        if(here->PTR_J_ge_e_required==1)
        {
          here->PTR_J_ge_e=SMPmakeElt(matrix,here->geNode,here->eNode);
        }
        if(here->PTR_J_ge_t_required==1)
        {
          here->PTR_J_ge_t=SMPmakeElt(matrix,here->geNode,here->tNode);
        }
        if(here->PTR_J_ge_si_required==1)
        {
          here->PTR_J_ge_si=SMPmakeElt(matrix,here->geNode,here->siNode);
        }
        if(here->PTR_J_ge_di_required==1)
        {
          here->PTR_J_ge_di=SMPmakeElt(matrix,here->geNode,here->diNode);
        }
        if(here->PTR_J_ge_s_required==1)
        {
          here->PTR_J_ge_s=SMPmakeElt(matrix,here->geNode,here->sNode);
        }
        if(here->PTR_J_si_s_required==1)
        {
          here->PTR_J_si_s=SMPmakeElt(matrix,here->siNode,here->sNode);
        }
        if(here->PTR_J_ge_d_required==1)
        {
          here->PTR_J_ge_d=SMPmakeElt(matrix,here->geNode,here->dNode);
        }
        if(here->PTR_J_si_d_required==1)
        {
          here->PTR_J_si_d=SMPmakeElt(matrix,here->siNode,here->dNode);
        }
        if(here->PTR_J_di_s_required==1)
        {
          here->PTR_J_di_s=SMPmakeElt(matrix,here->diNode,here->sNode);
        }
        if(here->PTR_J_di_d_required==1)
        {
          here->PTR_J_di_d=SMPmakeElt(matrix,here->diNode,here->dNode);
        }
        if(here->PTR_J_e_ge_required==1)
        {
          here->PTR_J_e_ge=SMPmakeElt(matrix,here->eNode,here->geNode);
        }
        if(here->PTR_J_e_si_required==1)
        {
          here->PTR_J_e_si=SMPmakeElt(matrix,here->eNode,here->siNode);
        }
        if(here->PTR_J_e_e_required==1)
        {
          here->PTR_J_e_e=SMPmakeElt(matrix,here->eNode,here->eNode);
        }
        if(here->PTR_J_e_di_required==1)
        {
          here->PTR_J_e_di=SMPmakeElt(matrix,here->eNode,here->diNode);
        }
        if(here->PTR_J_e_t_required==1)
        {
          here->PTR_J_e_t=SMPmakeElt(matrix,here->eNode,here->tNode);
        }
        if(here->PTR_J_e_s_required==1)
        {
          here->PTR_J_e_s=SMPmakeElt(matrix,here->eNode,here->sNode);
        }
        if(here->PTR_J_e_d_required==1)
        {
          here->PTR_J_e_d=SMPmakeElt(matrix,here->eNode,here->dNode);
        }
        if(here->PTR_J_d_d_required==1)
        {
          here->PTR_J_d_d=SMPmakeElt(matrix,here->dNode,here->dNode);
        }
        if(here->PTR_J_d_s_required==1)
        {
          here->PTR_J_d_s=SMPmakeElt(matrix,here->dNode,here->sNode);
        }
        if(here->PTR_J_s_d_required==1)
        {
          here->PTR_J_s_d=SMPmakeElt(matrix,here->sNode,here->dNode);
        }
        if(here->PTR_J_s_s_required==1)
        {
          here->PTR_J_s_s=SMPmakeElt(matrix,here->sNode,here->sNode);
        }
        if(here->PTR_J_s_t_required==1)
        {
          here->PTR_J_s_t=SMPmakeElt(matrix,here->sNode,here->tNode);
        }
        if(here->PTR_J_s_di_required==1)
        {
          here->PTR_J_s_di=SMPmakeElt(matrix,here->sNode,here->diNode);
        }
        if(here->PTR_J_s_si_required==1)
        {
          here->PTR_J_s_si=SMPmakeElt(matrix,here->sNode,here->siNode);
        }
        if(here->PTR_J_s_ge_required==1)
        {
          here->PTR_J_s_ge=SMPmakeElt(matrix,here->sNode,here->geNode);
        }
        if(here->PTR_J_s_e_required==1)
        {
          here->PTR_J_s_e=SMPmakeElt(matrix,here->sNode,here->eNode);
        }
        if(here->PTR_J_d_t_required==1)
        {
          here->PTR_J_d_t=SMPmakeElt(matrix,here->dNode,here->tNode);
        }
        if(here->PTR_J_d_di_required==1)
        {
          here->PTR_J_d_di=SMPmakeElt(matrix,here->dNode,here->diNode);
        }
        if(here->PTR_J_d_si_required==1)
        {
          here->PTR_J_d_si=SMPmakeElt(matrix,here->dNode,here->siNode);
        }
        if(here->PTR_J_d_ge_required==1)
        {
          here->PTR_J_d_ge=SMPmakeElt(matrix,here->dNode,here->geNode);
        }
        if(here->PTR_J_d_e_required==1)
        {
          here->PTR_J_d_e=SMPmakeElt(matrix,here->dNode,here->eNode);
        }
        if(here->PTR_J_g_g_required==1)
        {
          here->PTR_J_g_g=SMPmakeElt(matrix,here->gNode,here->gNode);
        }
        if(here->PTR_J_g_ge_required==1)
        {
          here->PTR_J_g_ge=SMPmakeElt(matrix,here->gNode,here->geNode);
        }
        if(here->PTR_J_ge_g_required==1)
        {
          here->PTR_J_ge_g=SMPmakeElt(matrix,here->geNode,here->gNode);
        }
        if(here->PTR_J_g_t_required==1)
        {
          here->PTR_J_g_t=SMPmakeElt(matrix,here->gNode,here->tNode);
        }
        if(here->PTR_J_di_N_required==1)
        {
          here->PTR_J_di_N=SMPmakeElt(matrix,here->diNode,here->NNode);
        }
        if(here->PTR_J_si_N_required==1)
        {
          here->PTR_J_si_N=SMPmakeElt(matrix,here->siNode,here->NNode);
        }
        if(here->PTR_J_N_ge_required==1)
        {
          here->PTR_J_N_ge=SMPmakeElt(matrix,here->NNode,here->geNode);
        }
        if(here->PTR_J_N_e_required==1)
        {
          here->PTR_J_N_e=SMPmakeElt(matrix,here->NNode,here->eNode);
        }
        if(here->PTR_J_N_si_required==1)
        {
          here->PTR_J_N_si=SMPmakeElt(matrix,here->NNode,here->siNode);
        }
        if(here->PTR_J_N_s_required==1)
        {
          here->PTR_J_N_s=SMPmakeElt(matrix,here->NNode,here->sNode);
        }
        if(here->PTR_J_N_di_required==1)
        {
          here->PTR_J_N_di=SMPmakeElt(matrix,here->NNode,here->diNode);
        }
        if(here->PTR_J_N_d_required==1)
        {
          here->PTR_J_N_d=SMPmakeElt(matrix,here->NNode,here->dNode);
        }
        if(here->PTR_J_N_t_required==1)
        {
          here->PTR_J_N_t=SMPmakeElt(matrix,here->NNode,here->tNode);
        }
        if(here->PTR_J_N_N_required==1)
        {
          here->PTR_J_N_N=SMPmakeElt(matrix,here->NNode,here->NNode);
        }
        if(here->PTR_J_ge_N_required==1)
        {
          here->PTR_J_ge_N=SMPmakeElt(matrix,here->geNode,here->NNode);
        }
        if(here->PTR_J_t_s_required==1)
        {
          here->PTR_J_t_s=SMPmakeElt(matrix,here->tNode,here->sNode);
        }
        if(here->PTR_J_t_si_required==1)
        {
          here->PTR_J_t_si=SMPmakeElt(matrix,here->tNode,here->siNode);
        }
        if(here->PTR_J_t_di_required==1)
        {
          here->PTR_J_t_di=SMPmakeElt(matrix,here->tNode,here->diNode);
        }
        if(here->PTR_J_t_d_required==1)
        {
          here->PTR_J_t_d=SMPmakeElt(matrix,here->tNode,here->dNode);
        }
        if(here->PTR_J_t_ge_required==1)
        {
          here->PTR_J_t_ge=SMPmakeElt(matrix,here->tNode,here->geNode);
        }
        if(here->PTR_J_t_e_required==1)
        {
          here->PTR_J_t_e=SMPmakeElt(matrix,here->tNode,here->eNode);
        }
        if(here->PTR_J_t_t_required==1)
        {
          here->PTR_J_t_t=SMPmakeElt(matrix,here->tNode,here->tNode);
        }

    }
  }
  return(OK);
}


int
bsimcmgunsetup(GENmodel *inModel, CKTcircuit *ckt)
{
  bsimcmgmodel *model = (bsimcmgmodel*)inModel;
  bsimcmginstance *here;

  /*  loop through all the bsimcmg device models */
  for ( ;model != NULL ;model = bsimcmgnextModel(model) )
  {
    for ( here = bsimcmginstances(model) ;here != NULL ; here = bsimcmgnextInstance(here) )
    {
        if (here->dNode_mine) {
            if (here->dNode > 0)
                CKTdltNNum(ckt, here->dNode);
            here->dNode_mine = 0;
        }
        if (!here->dNode_connected)
            here->dNode = -1;
        if (here->gNode_mine) {
            if (here->gNode > 0)
                CKTdltNNum(ckt, here->gNode);
            here->gNode_mine = 0;
        }
        if (!here->gNode_connected)
            here->gNode = -1;
        if (here->sNode_mine) {
            if (here->sNode > 0)
                CKTdltNNum(ckt, here->sNode);
            here->sNode_mine = 0;
        }
        if (!here->sNode_connected)
            here->sNode = -1;
        if (here->eNode_mine) {
            if (here->eNode > 0)
                CKTdltNNum(ckt, here->eNode);
            here->eNode_mine = 0;
        }
        if (!here->eNode_connected)
            here->eNode = -1;
        if (here->tNode_mine) {
            if (here->tNode > 0)
                CKTdltNNum(ckt, here->tNode);
            here->tNode_mine = 0;
        }
        if (!here->tNode_connected)
            here->tNode = -1;
        if (here->NNode_mine)
            if (here->NNode > 0)
                CKTdltNNum(ckt, here->NNode);
        here->NNode = -1;
        here->NNode_mine = 0;
        if (here->geNode_mine)
            if (here->geNode > 0)
                CKTdltNNum(ckt, here->geNode);
        here->geNode = -1;
        here->geNode_mine = 0;
        if (here->diNode_mine)
            if (here->diNode > 0)
                CKTdltNNum(ckt, here->diNode);
        here->diNode = -1;
        here->diNode_mine = 0;
        if (here->siNode_mine)
            if (here->siNode > 0)
                CKTdltNNum(ckt, here->siNode);
        here->siNode = -1;
        here->siNode_mine = 0;
    }
  }
  return OK;
}
