/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/complex.h"
#include "psp102defs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int psp102pzLoad(GENmodel *inModel, CKTcircuit *ckt, SPcomplex *s)
{
  psp102model *model = (psp102model*)inModel;
  psp102instance *here;
  NG_IGNOREABLE(ckt);
  for ( ; model != NULL; model = psp102nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = psp102instances(model); here != NULL ; here = psp102nextInstance(here))
    {  if(here->PTR_J_D_S_required) *(here->PTR_J_D_S)+=here->JSVAL_D_S *(s->real);
  if(here->PTR_J_D_BP_required) *(here->PTR_J_D_BP)+=here->JSVAL_D_BP *(s->real);
  if(here->PTR_J_BP_S_required) *(here->PTR_J_BP_S)+=here->JSVAL_BP_S *(s->real);
  if(here->PTR_J_BP_BP_required) *(here->PTR_J_BP_BP)+=here->JSVAL_BP_BP *(s->real);
  if(here->PTR_J_D_D_required) *(here->PTR_J_D_D)+=here->JSVAL_D_D *(s->real);
  if(here->PTR_J_BP_D_required) *(here->PTR_J_BP_D)+=here->JSVAL_BP_D *(s->real);
  if(here->PTR_J_D_GP_required) *(here->PTR_J_D_GP)+=here->JSVAL_D_GP *(s->real);
  if(here->PTR_J_BP_GP_required) *(here->PTR_J_BP_GP)+=here->JSVAL_BP_GP *(s->real);
  if(here->PTR_J_S_S_required) *(here->PTR_J_S_S)+=here->JSVAL_S_S *(s->real);
  if(here->PTR_J_S_BP_required) *(here->PTR_J_S_BP)+=here->JSVAL_S_BP *(s->real);
  if(here->PTR_J_S_D_required) *(here->PTR_J_S_D)+=here->JSVAL_S_D *(s->real);
  if(here->PTR_J_S_GP_required) *(here->PTR_J_S_GP)+=here->JSVAL_S_GP *(s->real);
  if(here->PTR_J_GP_S_required) *(here->PTR_J_GP_S)+=here->JSVAL_GP_S *(s->real);
  if(here->PTR_J_GP_BP_required) *(here->PTR_J_GP_BP)+=here->JSVAL_GP_BP *(s->real);
  if(here->PTR_J_GP_D_required) *(here->PTR_J_GP_D)+=here->JSVAL_GP_D *(s->real);
  if(here->PTR_J_GP_GP_required) *(here->PTR_J_GP_GP)+=here->JSVAL_GP_GP *(s->real);
  if(here->PTR_J_BS_S_required) *(here->PTR_J_BS_S)+=here->JSVAL_BS_S *(s->real);
  if(here->PTR_J_BS_BS_required) *(here->PTR_J_BS_BS)+=here->JSVAL_BS_BS *(s->real);
  if(here->PTR_J_S_BS_required) *(here->PTR_J_S_BS)+=here->JSVAL_S_BS *(s->real);
  if(here->PTR_J_BS_D_required) *(here->PTR_J_BS_D)+=here->JSVAL_BS_D *(s->real);
  if(here->PTR_J_BS_BD_required) *(here->PTR_J_BS_BD)+=here->JSVAL_BS_BD *(s->real);
  if(here->PTR_J_S_BD_required) *(here->PTR_J_S_BD)+=here->JSVAL_S_BD *(s->real);
  if(here->PTR_J_BD_S_required) *(here->PTR_J_BD_S)+=here->JSVAL_BD_S *(s->real);
  if(here->PTR_J_BD_BS_required) *(here->PTR_J_BD_BS)+=here->JSVAL_BD_BS *(s->real);
  if(here->PTR_J_D_BS_required) *(here->PTR_J_D_BS)+=here->JSVAL_D_BS *(s->real);
  if(here->PTR_J_BD_D_required) *(here->PTR_J_BD_D)+=here->JSVAL_BD_D *(s->real);
  if(here->PTR_J_BD_BD_required) *(here->PTR_J_BD_BD)+=here->JSVAL_BD_BD *(s->real);
  if(here->PTR_J_D_BD_required) *(here->PTR_J_D_BD)+=here->JSVAL_D_BD *(s->real);
  if(here->PTR_J_G_G_required) *(here->PTR_J_G_G)+=here->JSVAL_G_G *(s->real);
  if(here->PTR_J_G_GP_required) *(here->PTR_J_G_GP)+=here->JSVAL_G_GP *(s->real);
  if(here->PTR_J_GP_G_required) *(here->PTR_J_GP_G)+=here->JSVAL_GP_G *(s->real);
  if(here->PTR_J_BP_BI_required) *(here->PTR_J_BP_BI)+=here->JSVAL_BP_BI *(s->real);
  if(here->PTR_J_BI_BP_required) *(here->PTR_J_BI_BP)+=here->JSVAL_BI_BP *(s->real);
  if(here->PTR_J_BI_BI_required) *(here->PTR_J_BI_BI)+=here->JSVAL_BI_BI *(s->real);
  if(here->PTR_J_BS_BI_required) *(here->PTR_J_BS_BI)+=here->JSVAL_BS_BI *(s->real);
  if(here->PTR_J_BI_BS_required) *(here->PTR_J_BI_BS)+=here->JSVAL_BI_BS *(s->real);
  if(here->PTR_J_BD_BI_required) *(here->PTR_J_BD_BI)+=here->JSVAL_BD_BI *(s->real);
  if(here->PTR_J_BI_BD_required) *(here->PTR_J_BI_BD)+=here->JSVAL_BI_BD *(s->real);
  if(here->PTR_J_B_B_required) *(here->PTR_J_B_B)+=here->JSVAL_B_B *(s->real);
  if(here->PTR_J_B_BI_required) *(here->PTR_J_B_BI)+=here->JSVAL_B_BI *(s->real);
  if(here->PTR_J_BI_B_required) *(here->PTR_J_BI_B)+=here->JSVAL_BI_B *(s->real);
  if(here->PTR_J_NOI2_NOI2_required) *(here->PTR_J_NOI2_NOI2)+=here->JSVAL_NOI2_NOI2 *(s->real);
  if(here->PTR_J_NOI2_S_required) *(here->PTR_J_NOI2_S)+=here->JSVAL_NOI2_S *(s->real);
  if(here->PTR_J_NOI2_BP_required) *(here->PTR_J_NOI2_BP)+=here->JSVAL_NOI2_BP *(s->real);
  if(here->PTR_J_NOI2_GP_required) *(here->PTR_J_NOI2_GP)+=here->JSVAL_NOI2_GP *(s->real);
  if(here->PTR_J_NOI2_D_required) *(here->PTR_J_NOI2_D)+=here->JSVAL_NOI2_D *(s->real);
  if(here->PTR_J_NOI_S_required) *(here->PTR_J_NOI_S)+=here->JSVAL_NOI_S *(s->real);
  if(here->PTR_J_NOI_BP_required) *(here->PTR_J_NOI_BP)+=here->JSVAL_NOI_BP *(s->real);
  if(here->PTR_J_NOI_GP_required) *(here->PTR_J_NOI_GP)+=here->JSVAL_NOI_GP *(s->real);
  if(here->PTR_J_NOI_D_required) *(here->PTR_J_NOI_D)+=here->JSVAL_NOI_D *(s->real);
  if(here->PTR_J_NOI_NOI2_required) *(here->PTR_J_NOI_NOI2)+=here->JSVAL_NOI_NOI2 *(s->real);
  if(here->PTR_J_NOI_NOI_required) *(here->PTR_J_NOI_NOI)+=here->JSVAL_NOI_NOI *(s->real);
  if(here->PTR_J_BS_BP_required) *(here->PTR_J_BS_BP)+=here->JSVAL_BS_BP *(s->real);
  if(here->PTR_J_BS_GP_required) *(here->PTR_J_BS_GP)+=here->JSVAL_BS_GP *(s->real);
  if(here->PTR_J_BD_BP_required) *(here->PTR_J_BD_BP)+=here->JSVAL_BD_BP *(s->real);
  if(here->PTR_J_BD_GP_required) *(here->PTR_J_BD_GP)+=here->JSVAL_BD_GP *(s->real);
  if(here->PTR_J_D_S_required) *(here->PTR_J_D_S)+=here->JDVAL_D_S *(s->real);
  if(here->PTR_J_D_BP_required) *(here->PTR_J_D_BP)+=here->JDVAL_D_BP *(s->real);
  if(here->PTR_J_BP_S_required) *(here->PTR_J_BP_S)+=here->JDVAL_BP_S *(s->real);
  if(here->PTR_J_BP_BP_required) *(here->PTR_J_BP_BP)+=here->JDVAL_BP_BP *(s->real);
  if(here->PTR_J_D_D_required) *(here->PTR_J_D_D)+=here->JDVAL_D_D *(s->real);
  if(here->PTR_J_BP_D_required) *(here->PTR_J_BP_D)+=here->JDVAL_BP_D *(s->real);
  if(here->PTR_J_D_GP_required) *(here->PTR_J_D_GP)+=here->JDVAL_D_GP *(s->real);
  if(here->PTR_J_BP_GP_required) *(here->PTR_J_BP_GP)+=here->JDVAL_BP_GP *(s->real);
  if(here->PTR_J_S_S_required) *(here->PTR_J_S_S)+=here->JDVAL_S_S *(s->real);
  if(here->PTR_J_S_BP_required) *(here->PTR_J_S_BP)+=here->JDVAL_S_BP *(s->real);
  if(here->PTR_J_S_D_required) *(here->PTR_J_S_D)+=here->JDVAL_S_D *(s->real);
  if(here->PTR_J_S_GP_required) *(here->PTR_J_S_GP)+=here->JDVAL_S_GP *(s->real);
  if(here->PTR_J_GP_S_required) *(here->PTR_J_GP_S)+=here->JDVAL_GP_S *(s->real);
  if(here->PTR_J_GP_BP_required) *(here->PTR_J_GP_BP)+=here->JDVAL_GP_BP *(s->real);
  if(here->PTR_J_GP_D_required) *(here->PTR_J_GP_D)+=here->JDVAL_GP_D *(s->real);
  if(here->PTR_J_GP_GP_required) *(here->PTR_J_GP_GP)+=here->JDVAL_GP_GP *(s->real);
  if(here->PTR_J_BS_S_required) *(here->PTR_J_BS_S)+=here->JDVAL_BS_S *(s->real);
  if(here->PTR_J_BS_BS_required) *(here->PTR_J_BS_BS)+=here->JDVAL_BS_BS *(s->real);
  if(here->PTR_J_S_BS_required) *(here->PTR_J_S_BS)+=here->JDVAL_S_BS *(s->real);
  if(here->PTR_J_BS_D_required) *(here->PTR_J_BS_D)+=here->JDVAL_BS_D *(s->real);
  if(here->PTR_J_BS_BD_required) *(here->PTR_J_BS_BD)+=here->JDVAL_BS_BD *(s->real);
  if(here->PTR_J_S_BD_required) *(here->PTR_J_S_BD)+=here->JDVAL_S_BD *(s->real);
  if(here->PTR_J_BD_S_required) *(here->PTR_J_BD_S)+=here->JDVAL_BD_S *(s->real);
  if(here->PTR_J_BD_BS_required) *(here->PTR_J_BD_BS)+=here->JDVAL_BD_BS *(s->real);
  if(here->PTR_J_D_BS_required) *(here->PTR_J_D_BS)+=here->JDVAL_D_BS *(s->real);
  if(here->PTR_J_BD_D_required) *(here->PTR_J_BD_D)+=here->JDVAL_BD_D *(s->real);
  if(here->PTR_J_BD_BD_required) *(here->PTR_J_BD_BD)+=here->JDVAL_BD_BD *(s->real);
  if(here->PTR_J_D_BD_required) *(here->PTR_J_D_BD)+=here->JDVAL_D_BD *(s->real);
  if(here->PTR_J_NOI_S_required) *(here->PTR_J_NOI_S)+=here->JDVAL_NOI_S *(s->real);
  if(here->PTR_J_NOI_BP_required) *(here->PTR_J_NOI_BP)+=here->JDVAL_NOI_BP *(s->real);
  if(here->PTR_J_NOI_GP_required) *(here->PTR_J_NOI_GP)+=here->JDVAL_NOI_GP *(s->real);
  if(here->PTR_J_NOI_D_required) *(here->PTR_J_NOI_D)+=here->JDVAL_NOI_D *(s->real);
  if(here->PTR_J_NOI_NOI_required) *(here->PTR_J_NOI_NOI)+=here->JDVAL_NOI_NOI *(s->real);
  if(here->PTR_J_D_S_required) *(here->PTR_J_D_S+1)+=here->JDVAL_D_S *(s->imag);
  if(here->PTR_J_D_BP_required) *(here->PTR_J_D_BP+1)+=here->JDVAL_D_BP *(s->imag);
  if(here->PTR_J_BP_S_required) *(here->PTR_J_BP_S+1)+=here->JDVAL_BP_S *(s->imag);
  if(here->PTR_J_BP_BP_required) *(here->PTR_J_BP_BP+1)+=here->JDVAL_BP_BP *(s->imag);
  if(here->PTR_J_D_D_required) *(here->PTR_J_D_D+1)+=here->JDVAL_D_D *(s->imag);
  if(here->PTR_J_BP_D_required) *(here->PTR_J_BP_D+1)+=here->JDVAL_BP_D *(s->imag);
  if(here->PTR_J_D_GP_required) *(here->PTR_J_D_GP+1)+=here->JDVAL_D_GP *(s->imag);
  if(here->PTR_J_BP_GP_required) *(here->PTR_J_BP_GP+1)+=here->JDVAL_BP_GP *(s->imag);
  if(here->PTR_J_S_S_required) *(here->PTR_J_S_S+1)+=here->JDVAL_S_S *(s->imag);
  if(here->PTR_J_S_BP_required) *(here->PTR_J_S_BP+1)+=here->JDVAL_S_BP *(s->imag);
  if(here->PTR_J_S_D_required) *(here->PTR_J_S_D+1)+=here->JDVAL_S_D *(s->imag);
  if(here->PTR_J_S_GP_required) *(here->PTR_J_S_GP+1)+=here->JDVAL_S_GP *(s->imag);
  if(here->PTR_J_GP_S_required) *(here->PTR_J_GP_S+1)+=here->JDVAL_GP_S *(s->imag);
  if(here->PTR_J_GP_BP_required) *(here->PTR_J_GP_BP+1)+=here->JDVAL_GP_BP *(s->imag);
  if(here->PTR_J_GP_D_required) *(here->PTR_J_GP_D+1)+=here->JDVAL_GP_D *(s->imag);
  if(here->PTR_J_GP_GP_required) *(here->PTR_J_GP_GP+1)+=here->JDVAL_GP_GP *(s->imag);
  if(here->PTR_J_BS_S_required) *(here->PTR_J_BS_S+1)+=here->JDVAL_BS_S *(s->imag);
  if(here->PTR_J_BS_BS_required) *(here->PTR_J_BS_BS+1)+=here->JDVAL_BS_BS *(s->imag);
  if(here->PTR_J_S_BS_required) *(here->PTR_J_S_BS+1)+=here->JDVAL_S_BS *(s->imag);
  if(here->PTR_J_BS_D_required) *(here->PTR_J_BS_D+1)+=here->JDVAL_BS_D *(s->imag);
  if(here->PTR_J_BS_BD_required) *(here->PTR_J_BS_BD+1)+=here->JDVAL_BS_BD *(s->imag);
  if(here->PTR_J_S_BD_required) *(here->PTR_J_S_BD+1)+=here->JDVAL_S_BD *(s->imag);
  if(here->PTR_J_BD_S_required) *(here->PTR_J_BD_S+1)+=here->JDVAL_BD_S *(s->imag);
  if(here->PTR_J_BD_BS_required) *(here->PTR_J_BD_BS+1)+=here->JDVAL_BD_BS *(s->imag);
  if(here->PTR_J_D_BS_required) *(here->PTR_J_D_BS+1)+=here->JDVAL_D_BS *(s->imag);
  if(here->PTR_J_BD_D_required) *(here->PTR_J_BD_D+1)+=here->JDVAL_BD_D *(s->imag);
  if(here->PTR_J_BD_BD_required) *(here->PTR_J_BD_BD+1)+=here->JDVAL_BD_BD *(s->imag);
  if(here->PTR_J_D_BD_required) *(here->PTR_J_D_BD+1)+=here->JDVAL_D_BD *(s->imag);
  if(here->PTR_J_NOI_S_required) *(here->PTR_J_NOI_S+1)+=here->JDVAL_NOI_S *(s->imag);
  if(here->PTR_J_NOI_BP_required) *(here->PTR_J_NOI_BP+1)+=here->JDVAL_NOI_BP *(s->imag);
  if(here->PTR_J_NOI_GP_required) *(here->PTR_J_NOI_GP+1)+=here->JDVAL_NOI_GP *(s->imag);
  if(here->PTR_J_NOI_D_required) *(here->PTR_J_NOI_D+1)+=here->JDVAL_NOI_D *(s->imag);
  if(here->PTR_J_NOI_NOI_required) *(here->PTR_J_NOI_NOI+1)+=here->JDVAL_NOI_NOI *(s->imag);

    } /* End of MOSFET Instance */
  } /* End of Model Instance */
  return(OK);
}
