/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "psp103defs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int psp103trunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  psp103model *model = (psp103model*)inModel;
  psp103instance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = psp103nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = psp103instances(model); here != NULL ; here = psp103nextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_NOI_GND, ckt, timeStep);
            CKTterr(here->state_BP_SI, ckt, timeStep);
            CKTterr(here->state_BD_DI, ckt, timeStep);
            CKTterr(here->state_BS_SI, ckt, timeStep);
            CKTterr(here->state_GP_BP, ckt, timeStep);
            CKTterr(here->state_GP_DI, ckt, timeStep);
            CKTterr(here->state_GP_SI, ckt, timeStep);
            CKTterr(here->state_DI_SI, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->psp103name,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
